﻿; ########################################
; UTD2052CEL READER
; HAUPT-QUELLTEXT
; (C) BY NILS HINTZE
; ########################################



; ########################################
;- Eingebundene Quelltexte
; ########################################

XIncludeFile "dso.pbi"

XIncludeFile "NhMessageRequesterAppIcon.pbi"

XIncludeFile "NhOpenSaveDialog.pbi"

XIncludeFile "NhFormatString.pbi"



; ########################################
;- Konstanten
; ########################################

;- Versionsinformationen
#AppName = "UTD2052CEL Reader"
#AppAuthor = "Nils Hintze"
#AppHomepage = "http://www.elektronikpage.net/utd2052celreader/"
#AppVersionMajor = 0
#AppVersionMinor = 16
#AppVersionPatch = 1
#AppVersionBuild = #PB_Editor_BuildCount
#AppVersionDate = #PB_Compiler_Date

;- Enumeration der Image-Konstanten
Enumeration
  #Image_background
  #Image_ch1
  #Image_ch2
;   #Image_ch3
;   #Image_ch4
  #Image_chbwlim
  #Image_chcoupac
  #Image_chcoupdc
  #Image_chcoupgnd
  #Image_chinvert
  #Image_chprobe
  #Image_chvolt
  #Image_timediv
  #Image_trig
  #Image_trigauto
  #Image_trigcouphfrej
  #Image_trigcouplfrej
  #Image_trigequal
  #Image_triggreater
  #Image_triglesser
  #Image_triglevel
  #Image_trignorm
  #Image_trigoffset
  #Image_trigpolarityneg
  #Image_trigpolaritypos
  #Image_trigpulsewidth
  #Image_trigsingle
  #Image_trigslopefall
  #Image_trigsloperise
  #Image_trigsloperisefall
  #Image_trigsourcealter
  #Image_trigsourceext
  #Image_trigsourceline
  #Image_trigtypeedge
  #Image_trigtypepulse
EndEnumeration

;- Fenster
Enumeration
  ; Hauptfenster
  #Window_Main
EndEnumeration

;- Menüs
Enumeration
  ; Popup-Menü Messung
  #Menu_MDIWndCursorMeasurement
  ; Menüleiste Hauptfenster
  #Menu_MainWnd
EndEnumeration

;- Menüeinträge
Enumeration
  ; Popup-Menü Cursor-Messung
  #MenuItem_MDIWndPeak
  #MenuItem_MDIWndRMS
  #MenuItem_MDIWndMean
  ; Menüleiste Hauptfenster
  ; Menütitel "Datei"
  #MenuItem_MainWndLoadFile
  #MenuItem_MainWndPrint
  #MenuItem_MainWndExportImageFile
  #MenuItem_MainWndExportImageClipboard
  #MenuItem_MainWndExportCSVFile
  #MenuItem_MainWndExportLTspiceRAWFile
  #MenuItem_MainWndQuit
  ; Menütitel "?"
  #MenuItem_MainWndAbout
  #MenuItem_MainWndOpenWebsite
  #MenuItem_MainWndOpenHelp
  ; Menütitel "Fenster"
  #MenuItem_MainWndTileVertically
  #MenuItem_MainWndTileHorizontally
  #MenuItem_MainWndCascade
  #MenuItem_MainWndCloseAll
  #MenuItem_MainWndMDIWindowList ; Muss immer am Ende stehen!
EndEnumeration

;- Gadgets
Enumeration
  ; Gadgets Hauptfenster
  #MDI_MainWnd
  ; Gadgets Druck-Dialog
  #Frame_PrintDlgPreview
  #Image_PrintDlgPreview
  #ScrollBar_PrintDlgHorizontalOffset
  #ScrollBar_PrintDlgVerticalOffset
  #Text_PrintDlgZoomLabel
  #TrackBar_PrintDlgZoom
  #Button_PrintDlgPrint
  #Button_PrintDlgCancel
  ; Gadgets Math-Dialog
  #Text_MathDlgFirstChannelLabel
  #ComboBox_MathDlgFirstChannel
  #Text_MathDlgOperationLabel
  #ComboBox_MathDlgOperation
  #Text_MathDlgSecondChannelLabel
  #ComboBox_MathDlgSecondChannel
  #Text_MathDlgVoltPerDivLabel
  #ComboBox_MathDlgVoltPerDivValue
  #ComboBox_MathDlgVoltPerDivUnit
  #Text_MathDlgOffsetLabel
  #TrackBar_MathDlgOffset
  #Button_MathDlgOK
  #Button_MathDlgCancel
  #Button_MathDlgDisable
EndEnumeration

;- Maximale Diagrammgröße in einem MDIWindow
#WaveformCanvasMaximumWidth = 600
#WaveformCanvasMaximumHeight = 400

;- Maximale Vorschaubildgröße im Druck-Dialog
#PrintPreviewImageMaximumWidth = 290
#PrintPreviewImageMaximumHeight = 290

;- Hilfedatei
#HelpFileName = "utd2052celreader.chm"



; ########################################
;- Strukturen
; ########################################

Structure DLGTEMPLATE2 Extends DLGTEMPLATE
  menu.u
  class.u
  title.u
EndStructure

Structure MDIWindow
  Window.i
  Update.i
  DisplayOffset.i
  DisplayLength.i
  OldDisplayLength.i
  EnableCursors.i
  Cursor1.i
  Cursor2.i
  WaveformCanvasWidth.i
  WaveformCanvasHeight.i
  Canvas_Waveform.i
  ScrollBar_Offset.i
  Tree_Settings.i
  Text_Zoom.i
  TrackBar_Zoom.i
  CheckBox_EnableCursors.i
  Frame_Cursor1.i
  Editor_Cursor1Data.i
  Frame_Cursor2.i
  Editor_Cursor2Data.i
  Frame_CursorDiff.i
  Editor_CursorDiffData.i
  Button_SelectAll.i
  Button_CursorMeasurement.i
  Button_MathFunctions.i
  Text_MathVoltPerDiv.i
  Frame_CursorMeasurement.i
  Editor_CursorMeasurementData.i
  DSOData.DSOData
EndStructure

Structure PrintDialogValues
  PreviewImage.i
  PreviewImageWidth.i
  PreviewImageHeight.i
  PageWidth.i
  PageHeight.i
  DiagramX.i
  DiagramY.i
  DiagramWidth.i
  DiagramHeight.i
  MaximumDiagramWidth.i
  MaximumDiagramHeight.i
EndStructure

Structure MathDialogValues
  Operation.i
  xOperand.i
  yOperand.i
  VoltPerDiv.d
  Offset.d
  x.d
  y.d
EndStructure



; ########################################
;- Variablen
; ########################################

#ZoomFactorCount = 10
Global Dim ZoomFactor(#ZoomFactorCount-1)
ZoomFactor(0) = 100
ZoomFactor(1) = 80
ZoomFactor(2) = 60
ZoomFactor(3) = 50
ZoomFactor(4) = 40
ZoomFactor(5) = 30
ZoomFactor(6) = 25
ZoomFactor(7) = 20
ZoomFactor(8) = 10
ZoomFactor(9) = 5

Global NewList MDIWindow.MDIWindow()

Global PrintDialogValues.PrintDialogValues, MathDialogValues.MathDialogValues



; ########################################
;- Prozeduren
; ########################################

; Versionsstring erzeugen
Macro VersionString(Major, Minor, Patch, Build)
  Str(Major)+"."+Str(Minor)+"."+Str(Patch)+"-"+Str(Build)
EndMacro

; Allgemeine Meldungen
Macro ErrorMessage(Message, Flags = #PB_MessageRequester_Ok)
  MessageRequester("Fehler", Message, (Flags)|#MB_ICONERROR)
EndMacro
Macro InfoMessage(Message, Flags = #PB_MessageRequester_Ok)
  MessageRequester("Information", Message, (Flags)|#MB_ICONINFORMATION)
EndMacro
Macro WarningMessage(Message, Flags = #PB_MessageRequester_Ok)
  MessageRequester("Warnung", Message, (Flags)|#MB_ICONWARNING)
EndMacro
Macro QuestionMessage(Message, Flags = #PB_MessageRequester_Ok)
  MessageRequester("Frage", Message, (Flags)|#MB_ICONQUESTION)
EndMacro

; String in Double umwandeln mit Berücksichtigung von SI-Präfixen
Procedure.d ValDSIPrefix(String$)
  Protected *c.Character, Exp
  *c = @String$
  While *c\c
    Select *c\c
      Case ','
        *c\c = '.'
      Case 'k'
        *c\c = '.'
        Exp = 3
        Break
      Case 'm'
        *c\c = '.'
        Exp = -3
        Break
      Case 'M'
        *c\c = '.'
        Exp = 6
        Break
      Case 'µ', 'u'
        *c\c = '.'
        Exp = -6
        Break
      Case 'G'
        *c\c = '.'
        Exp = 9
        Break
      Case 'n'
        *c\c = '.'
        Exp = -9
        Break
      Case 'T'
        *c\c = '.'
        Exp = 12
        Break
      Case 'p'
        *c\c = '.'
        Exp = -12
        Break
    EndSelect
    *c + SizeOf(Character)
  Wend
  ProcedureReturn ValD(String$) * Pow(10, Exp)
EndProcedure

; Popup-Menü unterhalb eines Gadgets anzeigen
Procedure DisplayPopupMenuBelowGadget(Menu, WindowID, Gadget)
  Protected Position.POINT
  MapWindowPoints_(GadgetID(Gadget), #Null, @Position, 1)
  DisplayPopupMenu(Menu, WindowID, Position\x, Position\y+GadgetHeight(Gadget))
EndProcedure

; FormatString() mit direkter Übergabe von Typen und Zeigern
Procedure.s QuickFormatString(String$, Var1Type = 0, *Var1Ptr = 0, Var2Type = 0, *Var2Ptr = 0, Var3Type = 0, *Var3Ptr = 0, Var4Type = 0, *Var4Ptr = 0)
  Protected FSV.FormatStringVariables
  FSV\Var[0]\Type = Var1Type
  FSV\Var[0]\Pointer = *Var1Ptr
  FSV\Var[1]\Type = Var2Type
  FSV\Var[1]\Pointer = *Var2Ptr
  FSV\Var[2]\Type = Var3Type
  FSV\Var[2]\Pointer = *Var3Ptr
  FSV\Var[3]\Type = Var4Type
  FSV\Var[3]\Pointer = *Var4Ptr
  ProcedureReturn FormatString(String$, @FSV)
EndProcedure

; Kanalname erzeugen
Procedure.s MakeChannelName(c)
  If IsChannelCH(c)
    c + 1
    ProcedureReturn QuickFormatString("Kanal {0}", #FormatString_Integer, @c)
  ElseIf IsChannelMath(c)
    ProcedureReturn "Math"
  EndIf
EndProcedure

; Diagramm zeichnen
Structure PenStruct
  *Handle
  Style.i
  Width.i
  Color.i
EndStructure
Procedure CreatePen(*hDC, *Pen.PenStruct)
  If *Pen\Handle
    SelectObject_(*hDC, GetStockObject_(#NULL_PEN))
    DeleteObject_(*Pen\Handle)
  EndIf
  *Pen\Handle = CreatePen_(*Pen\Style, *Pen\Width, *Pen\Color)
  ProcedureReturn *Pen\Handle
EndProcedure
Macro SetPenAttributes(PenStruct, Style_, Width_, Color_)
  PenStruct\Style = Style_
  PenStruct\Width = Width_
  PenStruct\Color = Color_
EndMacro
Procedure UsePen(*hDC, *Pen.PenStruct)
  If *Pen\Handle
    SelectObject_(*hDC, *Pen\Handle)
  EndIf
EndProcedure
Procedure FreePen(*hDC, *Pen.PenStruct)
  If *Pen\Handle
    SelectObject_(*hDC, GetStockObject_(#NULL_PEN))
    DeleteObject_(*Pen\Handle)
    *Pen\Handle = 0
  EndIf
EndProcedure
Macro DW_LineXY(x1, y1, x2, y2)
  MoveToEx_(*hDC, OffsetX+(x1), OffsetY+(y1), #Null)
  LineTo_(*hDC, OffsetX+(x2), OffsetY+(y2))
EndMacro
Macro DW_Text(x, y, Text, Color, Spacing = 0)
  DrawText(OffsetX+(x), OffsetY+(y), Text, Color)
  x = (x) + TextWidth(Text) + (Spacing)
EndMacro
Procedure DrawWaveform(*DSOData.DSOData, Output, Width, Height, DisplayOffset, DisplayLength, Print = 0, ShowTriggerPoint = 0, ShowVoltPerDiv = 0, ShowTimePerDiv = 0, ShowFileName = 0, OffsetX = 0, OffsetY = 0, ShowCursors = 0, Cursor1 = 0, Cursor2 = 0, ClearOutput = 0)

  CompilerIf #PB_Compiler_Debugger And #False
    #DrawWaveform_Benchmark = #True
    DisableDebugger
    QueryPerformanceFrequency_(@PerfCntFreq.q)
    QueryPerformanceCounter_(@PerfCntStart.q)
  CompilerEndIf

  GridPen.PenStruct
  LightGridPen.PenStruct
  TrigPen.PenStruct
  Cursor1Pen.PenStruct
  Cursor2Pen.PenStruct
  FramePen.PenStruct
  Dim ChannelPen.PenStruct(#DSO_LastChannelIndex)
  Dim DarkChannelPen.PenStruct(#DSO_LastChannelIndex)
  
  If Print ; Druckdarstellung
    
    ; Linienbreite
    BaseWidth = Height / 400
    If BaseWidth < 1
      BaseWidth = 1
    EndIf
    
    ; Farben
    BackgroundColor   = $FFFFFF
    TimeTextColor     = $000000
    FileNameTextColor = $000000

    ; Pen-Attribute
    SetPenAttributes(GridPen,      #PS_SOLID, BaseWidth*1, $C0C0C0)
    SetPenAttributes(LightGridPen, #PS_SOLID, BaseWidth*1, $808080)
    SetPenAttributes(TrigPen,      #PS_SOLID, BaseWidth*1, $00FF00)
    SetPenAttributes(Cursor1Pen,   #PS_SOLID, BaseWidth*1, $FFFF00)
    SetPenAttributes(Cursor2Pen,   #PS_SOLID, BaseWidth*1, $FF00FF)
    SetPenAttributes(FramePen,     #PS_SOLID, BaseWidth*3, $000000)
    SetPenAttributes(ChannelPen    (#DSO_CH1),  #PS_SOLID, BaseWidth*2, $0000FF)
    SetPenAttributes(DarkChannelPen(#DSO_CH1),  #PS_SOLID, BaseWidth*1, $000080)
    SetPenAttributes(ChannelPen    (#DSO_CH2),  #PS_SOLID, BaseWidth*2, $FF0000)
    SetPenAttributes(DarkChannelPen(#DSO_CH2),  #PS_SOLID, BaseWidth*1, $800000)
;     SetPenAttributes(ChannelPen    (#DSO_CH3),  #PS_SOLID, BaseWidth*2, $FFFF00)
;     SetPenAttributes(DarkChannelPen(#DSO_CH3),  #PS_SOLID, BaseWidth*1, $808000)
;     SetPenAttributes(ChannelPen    (#DSO_CH4),  #PS_SOLID, BaseWidth*2, $00FFFF)
;     SetPenAttributes(DarkChannelPen(#DSO_CH4),  #PS_SOLID, BaseWidth*1, $008080)
    SetPenAttributes(ChannelPen    (#DSO_Math), #PS_SOLID, BaseWidth*2, $4080FF)
    SetPenAttributes(DarkChannelPen(#DSO_Math), #PS_SOLID, BaseWidth*1, $004080)
    
    ; Schrift
    PrintingFontSize = Height / 40
    If PrintingFontSize < 1
      PrintingFontSize  = 1
    EndIf
    PrintingFont = LoadFont(#PB_Any, "Helvetica", PrintingFontSize)
    If PrintingFont
      Font = FontID(PrintingFont)
    Else
      Font = #PB_Default
    EndIf
    
  Else ; Bildschirmdarstellung

    ; Farben
    BackgroundColor   = $000000
    TimeTextColor     = $FFFFFF
    FileNameTextColor = $FFFFFF
    
    ; Pen-Attribute
    SetPenAttributes(GridPen,      #PS_SOLID, 1, $404040)
    SetPenAttributes(LightGridPen, #PS_SOLID, 1, $808080)
    SetPenAttributes(TrigPen,      #PS_SOLID, 1, $FF00FF)
    SetPenAttributes(Cursor1Pen,   #PS_SOLID, 1, $0000FF)
    SetPenAttributes(Cursor2Pen,   #PS_SOLID, 1, $00FF00)
    SetPenAttributes(FramePen,     #PS_SOLID, 1, $000000)
    SetPenAttributes(ChannelPen    (#DSO_CH1),  #PS_SOLID, 1, $FFFF00)
    SetPenAttributes(DarkChannelPen(#DSO_CH1),  #PS_SOLID, 1, $808000)
    SetPenAttributes(ChannelPen    (#DSO_CH2),  #PS_SOLID, 1, $00FFFF)
    SetPenAttributes(DarkChannelPen(#DSO_CH2),  #PS_SOLID, 1, $008080)
;     SetPenAttributes(ChannelPen    (#DSO_CH3),  #PS_SOLID, 1, $0000FF)
;     SetPenAttributes(DarkChannelPen(#DSO_CH3),  #PS_SOLID, 1, $000080)
;     SetPenAttributes(ChannelPen    (#DSO_CH4),  #PS_SOLID, 1, $FF0000)
;     SetPenAttributes(DarkChannelPen(#DSO_CH4),  #PS_SOLID, 1, $800000)
    SetPenAttributes(ChannelPen    (#DSO_Math), #PS_SOLID, 1, $4080FF)
    SetPenAttributes(DarkChannelPen(#DSO_Math), #PS_SOLID, 1, $004080)
    
    ; Schrift
    Font = #PB_Default

  EndIf

  *hDC = StartDrawing(Output)
  If *hDC
    
    ; Pens erstellen
    CreatePen(*hDC, GridPen)
    CreatePen(*hDC, LightGridPen)
    CreatePen(*hDC, TrigPen)
    CreatePen(*hDC, Cursor1Pen)
    CreatePen(*hDC, Cursor2Pen)
    CreatePen(*hDC, FramePen)
    For c = 0 To #DSO_LastChannelIndex
      CreatePen(*hDC, ChannelPen(c))
      CreatePen(*hDC, DarkChannelPen(c))
    Next
    
    ; Bild löschen
    If ClearOutput
      Box(0, 0, OutputWidth(), OutputHeight(), BackgroundColor)
    Else
      Box(OffsetX, OffsetY, Width, Height, BackgroundColor)
    EndIf
    
    ; Diverse Vorberechnungen
    DivWidth = Width / *DSOData\HorDivs
    DivHeight = Height / *DSOData\VertDivs
    ZeroX = Width / 2
    ZeroY = Height / 2

    ; Raster zeichnen
    UsePen(*hDC, GridPen)
    For n = 0 To *DSOData\HorDivs - 1
      x = Width * n / *DSOData\HorDivs
      DW_LineXY(x, 0, x, Height)
    Next
    For n = 0 To *DSOData\VertDivs - 1
      y = Height * n / *DSOData\VertDivs
      DW_LineXY(0, y, Width, y)
    Next
    UsePen(*hDC, LightGridPen)
    DW_LineXY(ZeroX, 0, ZeroX, Height)
    DW_LineXY(0, ZeroY, Width, ZeroY)

    ; Kanal-Nullpunkte zeichnen
    For c = 0 To #DSO_LastChannelIndex
      If *DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
        UsePen(*hDC, DarkChannelPen(c))
        y = ZeroY - *DSOData\ChannelOffset[c] * DivHeight
        DW_LineXY(0, y, Width, y)
      EndIf
    Next
    
    ; Kanal-Daten zeichnen
    CompilerIf #True ; Neuer beschleunigter Algorithmus

      Structure Peaks
        StructureUnion
          MinimumPoint.i
          FirstPeakY.i
        EndStructureUnion
        StructureUnion
          MaximumPoint.i
          LastPeakY.i
        EndStructureUnion
      EndStructure

      If DisplayLength > Width ; Mehr Datenpunkte als Pixel
        
        Dim Peaks.Peaks(Width-1)
        Value.d
        Min.d
        Max.d
        *Peak.Peaks
        *LastPeak.Peaks
        
        For c = 0 To #DSO_LastChannelIndex
          If *DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On ; Kanal aktiv
            
            For n = 0 To DisplayLength - 1
              x = Width * n / DisplayLength
              Value = *DSOData\ChannelData[c]\Value[DisplayOffset+n]
              If x > lx Or n = 0 ; Neue X-Koordinate erreicht oder erster Durchlauf
                *Peak = @Peaks(x)
                Min = Value
                Max = Value
                *Peak\MinimumPoint = n
                *Peak\MaximumPoint = n
                lx = x
              ElseIf Value < Min
                Min = Value
                *Peak\MinimumPoint = n
              ElseIf Value > Max
                Max = Value
                *Peak\MaximumPoint = n
              EndIf
            Next
            
            ; Vorderes und hinteres Extrem innerhalb einer X-Koordinate finden
            For x = 0 To Width - 1
              *Peak = @Peaks(x)
              If *Peak\MaximumPoint < *Peak\MinimumPoint ; Maximum liegt vor Minimum
                Swap *Peak\MaximumPoint, *Peak\MinimumPoint
              EndIf
              *Peak\FirstPeakY = ZeroY - *DSOData\ChannelData[c]\Value[DisplayOffset+*Peak\MinimumPoint] * DivHeight
              *Peak\LastPeakY = ZeroY - *DSOData\ChannelData[c]\Value[DisplayOffset+*Peak\MaximumPoint] * DivHeight
            Next
            
            UsePen(*hDC, ChannelPen(c))
            For x = 0 To Width - 1
              *Peak = @Peaks(x)
              If x > 0 ; Nicht die erste Linie
                DW_LineXY(x-1, *LastPeak\LastPeakY, x, *Peak\FirstPeakY)
              EndIf
              DW_LineXY(x, *Peak\FirstPeakY, x, *Peak\LastPeakY)
              *LastPeak = *Peak
            Next
            
          EndIf
        Next
        
      Else ; Nicht mehr Datenpunkte als Pixel

        For c = 0 To #DSO_LastChannelIndex
          If *DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On ; Kanal aktiv
            UsePen(*hDC, ChannelPen(c))
            For n = 0 To DisplayLength - 1
              x = Width * n / DisplayLength
              y = ZeroY - *DSOData\ChannelData[c]\Value[DisplayOffset+n] * DivHeight
              If n > 0 ; Nicht der erste Datenpunkt
                DW_LineXY(lx, ly, x, y)
              EndIf
              lx = x
              ly = y
            Next
          EndIf
        Next
        
      EndIf
      
    CompilerElse ; Alter Algorithmus

      For c = 0 To #DSO_LastChannelIndex
        If *DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On ; Kanal aktiv
          UsePen(*hDC, ChannelPen(c))
          For n = 0 To DisplayLength - 1
            x = Width * n / DisplayLength
            y = ZeroY - *DSOData\ChannelData[c]\Value[DisplayOffset+n] * DivHeight
            If n > 0 ; Nicht der erste Datenpunkt
              DW_LineXY(lx, ly, x, y)
            EndIf
            lx = x
            ly = y
          Next
        EndIf
      Next

    CompilerEndIf
      
    ; Triggerpunkt zeichnen
    If ShowTriggerPoint
      UsePen(*hDC, TrigPen)
      x = Width * (*DSOData\TriggerPoint - DisplayOffset) / DisplayLength
      DW_LineXY(x, 0, x, Height)
    EndIf
    
    ; Cursor zeichnen
    If ShowCursors
      UsePen(*hDC, Cursor1Pen)
      x = Width * (Cursor1 - DisplayOffset) / DisplayLength
      DW_LineXY(x, 0, x, Height)
      UsePen(*hDC, Cursor2Pen)
      x = Width * (Cursor2 - DisplayOffset) / DisplayLength
      DW_LineXY(x, 0, x, Height)
    EndIf
  
    ; Legende zeichnen
    DrawingFont(Font)
    DrawingMode(#PB_2DDrawing_Transparent)
    x = Height / 80
    y = Height / 80
    Spacing = 3 * TextWidth(" ")
    For c = 0 To #DSO_LastChannelIndex
      If *DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
        If IsChannelCH(c)
          ChannelName$ = "CH" + Str(c+1)
        ElseIf IsChannelMath(c)
          ChannelName$ = "MATH"
        EndIf
        If ShowVoltPerDiv
          Text$ = QuickFormatString("{0}: {1Sd5}V/DIV", #FormatString_String, @ChannelName$, #FormatString_Double, @*DSOData\ChannelVoltPerDiv[c])
        Else
          Text$ = ChannelName$
        EndIf
        DW_Text(x, y, Text$, ChannelPen(c)\Color, Spacing)
      EndIf
    Next
    If ShowTriggerPoint
      DW_Text(x, y, "TRIG", TrigPen\Color, Spacing)
    EndIf
    If ShowTimePerDiv
      CurrentTimePerDiv.d = *DSOData\TimePerDiv * DisplayLength / *DSOData\PointsPerChannel
      Text$ = QuickFormatString("TIME: {0Sd5}s/DIV", #FormatString_Double, @CurrentTimePerDiv)
      DW_Text(x, y, Text$, TimeTextColor, Spacing)
    EndIf
    If ShowCursors
      DW_Text(x, y, "CUR1", Cursor1Pen\Color, Spacing)
      DW_Text(x, y, "CUR2", Cursor2Pen\Color, Spacing)
    EndIf
    If ShowFileName
      Text$ = GetFilePart(*DSOData\FileName, #PB_FileSystem_NoExtension)
      DW_Text(x, y, Text$, FileNameTextColor, Spacing)
    EndIf
    
    ; Rahmen zeichnen
    If Print
      UsePen(*hDC, FramePen)
      DW_LineXY(0, 0, Width, 0)
      DW_LineXY(0, Height-1, Width, Height-1)
      DW_LineXY(0, 0, 0, Height)
      DW_LineXY(Width-1, 0, Width-1, Height)
    EndIf
    
    ; Pens freigeben
    FreePen(*hDC, GridPen)
    FreePen(*hDC, LightGridPen)
    FreePen(*hDC, TrigPen)
    FreePen(*hDC, Cursor1Pen)
    FreePen(*hDC, Cursor2Pen)
    FreePen(*hDC, FramePen)
    For c = 0 To #DSO_LastChannelIndex
      FreePen(*hDC, ChannelPen(c))
      FreePen(*hDC, DarkChannelPen(c))
    Next

    StopDrawing()

  EndIf
  
  ; Schrift freigeben
  If PrintingFont
    FreeFont(PrintingFont)
  EndIf
  
  CompilerIf Defined(DrawWaveform_Benchmark, #PB_Constant)
    QueryPerformanceCounter_(@PerfCntEnd.q)
    EnableDebugger
    Debug 1000.0 * (PerfCntEnd - PerfCntStart) / PerfCntFreq
  CompilerEndIf
  
EndProcedure

; Diagramm als PNG-Datei exportieren
; Element in MDIWindow() muss selektiert sein!
Procedure ExportWaveformImageFile(FileName$)
  Result = #False
  With MDIWindow()
    Image = CreateImage(#PB_Any, \WaveformCanvasWidth, \WaveformCanvasHeight)
    If Image
      DrawWaveform(@\DSOData, ImageOutput(Image), \WaveformCanvasWidth, \WaveformCanvasHeight, \DisplayOffset, \DisplayLength, 0, 1, 1, 1, 0, 0, 0, \EnableCursors, \Cursor1, \Cursor2)
      If SaveImage(Image, FileName$, #PB_ImagePlugin_PNG)
        Result = #True
      EndIf
      FreeImage(Image)
    EndIf
  EndWith
  ProcedureReturn Result
EndProcedure

; Diagramm in die Zwischenablage kopieren
; Element in MDIWindow() muss selektiert sein!
Procedure ExportWaveformImageClipboard()
  With MDIWindow()
    Image = CreateImage(#PB_Any, \WaveformCanvasWidth, \WaveformCanvasHeight)
    If Image
      DrawWaveform(@\DSOData, ImageOutput(Image), \WaveformCanvasWidth, \WaveformCanvasHeight, \DisplayOffset, \DisplayLength, 0, 1, 1, 1, 0, 0, 0, \EnableCursors, \Cursor1, \Cursor2)
      SetClipboardImage(Image)
      FreeImage(Image)
    EndIf
  EndWith
EndProcedure

; Daten als CSV-Datei exportieren
; Element in MDIWindow() muss selektiert sein!
Procedure ExportWaveformCSVFile(FileName$)
  File = CreateFile(#PB_Any, FileName$)
  If File
    For n = 0 To MDIWindow()\DSOData\PointsPerChannel - 1
      Line$ = FS_StrD(DataPointTime(@MDIWindow()\DSOData, n), 15)
      For c = 0 To #DSO_LastCHIndex
        Line$ + "," + FS_StrD(DataPointVoltage(@MDIWindow()\DSOData, c, n), 15)
      Next
      WriteStringN(File, Line$)
    Next
    CloseFile(File)
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

; Daten als LTspice-RAW-Datei exportieren
; Element in MDIWindow() muss selektiert sein!
Procedure ExportWaveformLTspiceRAWFile(FileName$)
  File = CreateFile(#PB_Any, FileName$)
  If File
    WriteStringN(File, "Title: * "+MDIWindow()\DSOData\FileName)
    CurrentDate = Date()
    WriteString(File, "Date: ")
    WriteString(File, Mid("SunMonTueWedThuFriSat", DayOfWeek(CurrentDate)*3+1, 3)+" ")
    WriteString(File, Mid("JanFebMarAprMayJunJulAugSepOctNovDec", (Month(CurrentDate)-1)*3+1, 3)+" ")
    WriteStringN(File, FormatDate("%dd %hh:%ii:%ss %yyyy", CurrentDate))
    WriteStringN(File, "Plotname: "+GetFilePart(MDIWindow()\DSOData\FileName, #PB_FileSystem_NoExtension))
    WriteStringN(File, "Flags: real forward")
    VariableCount = 1
    For c = 0 To #DSO_LastCHIndex
      If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
        VariableCount + 1
      EndIf
    Next
    WriteStringN(File, "No. Variables: "+Str(VariableCount))
    WriteStringN(File, "No. Points: "+Str(MDIWindow()\DSOData\PointsPerChannel))
    WriteStringN(File, "Offset: 0")
    WriteStringN(File, "Command: "+#AppName+" LTspice RAW Export")
    WriteStringN(File, "Variables:")
    WriteStringN(File, #TAB$+"0"+#TAB$+"time"+#TAB$+"time")
    n = 1
    For c = 0 To #DSO_LastCHIndex
      If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
        WriteStringN(File, #TAB$+Str(n)+#TAB$+"V(CH"+Str(c+1)+")"+#TAB$+"voltage")
        n + 1
      EndIf
    Next
    WriteStringN(File, "Values:")
    For n = 0 To MDIWindow()\DSOData\PointsPerChannel - 1
      WriteStringN(File, Str(n)+#TAB$+#TAB$+FS_StrD(DataPointTime(@MDIWindow()\DSOData, n), 15))
      For c = 0 To #DSO_LastCHIndex
        If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
          WriteStringN(File, #TAB$+FS_StrD(DataPointVoltage(@MDIWindow()\DSOData, c, n), 15))
        EndIf
      Next
    Next
    CloseFile(File)
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

; Pixel in Dialog-Einheiten konvertieren.
Macro PixelsToDialogTemplateUnitsX(x)
  ((x) * 4 / (GetDialogBaseUnits_() & $FFFF))
EndMacro
Macro PixelsToDialogTemplateUnitsY(y)
  ((y) * 8 / (GetDialogBaseUnits_() >> 16))
EndMacro

; Diverse Prozeduren für Druck-Dialog
Procedure PrintDialogUpdateOffset()
  
  With PrintDialogValues
  
    ; Offsets übernehmen
    \DiagramX = GetGadgetState(#ScrollBar_PrintDlgHorizontalOffset)
    \DiagramY = GetGadgetState(#ScrollBar_PrintDlgVerticalOffset)
    
  EndWith
  
EndProcedure
Procedure PrintDialogUpdateZoom()
  
  With PrintDialogValues
  
    ; Zoomfaktor
    ZoomFactorPercent = GetGadgetState(#TrackBar_PrintDlgZoom) + 1
    SetGadgetText(#Text_PrintDlgZoomLabel, QuickFormatString("Zoom: {0} %", #FormatString_Integer, @ZoomFactorPercent))
    
    ; Neue Diagrammmaße
    \DiagramWidth = \MaximumDiagramWidth * ZoomFactorPercent / 100
    \DiagramHeight = \MaximumDiagramHeight * ZoomFactorPercent / 100
    
    ; Horizontaler Offsetregler
    Maximum = \PageWidth - \DiagramWidth
    PageLength = Maximum / 10
    SetGadgetAttribute(#ScrollBar_PrintDlgHorizontalOffset, #PB_ScrollBar_Maximum, Maximum+PageLength-1)
    SetGadgetAttribute(#ScrollBar_PrintDlgHorizontalOffset, #PB_ScrollBar_PageLength, PageLength)
    \DiagramX = Maximum / 2
    SetGadgetState(#ScrollBar_PrintDlgHorizontalOffset, \DiagramX)
    
    ; Vertikaler Offsetregler
    Maximum = \PageHeight - \DiagramHeight
    PageLength = Maximum / 10
    SetGadgetAttribute(#ScrollBar_PrintDlgVerticalOffset, #PB_ScrollBar_Maximum, Maximum+PageLength-1)
    SetGadgetAttribute(#ScrollBar_PrintDlgVerticalOffset, #PB_ScrollBar_PageLength, PageLength)
    \DiagramY = Maximum / 2
    SetGadgetState(#ScrollBar_PrintDlgVerticalOffset, \DiagramY)
    
  EndWith
  
EndProcedure
Procedure PrintDialogUpdatePreview()
  
  With PrintDialogValues

    ; Diagramm zeichnen und anzeigen
    DrawWaveform(@MDIWindow()\DSOData, ImageOutput(\PreviewImage), \DiagramWidth*\PreviewImageWidth/\PageWidth, \DiagramHeight*\PreviewImageHeight/\PageHeight, MDIWindow()\DisplayOffset,  MDIWindow()\DisplayLength, 1, 0, 1, 1, 1, \DiagramX*\PreviewImageWidth/\PageWidth, \DiagramY*\PreviewImageHeight/\PageHeight, 0, 0, 0, 1)
    SetGadgetState(#Image_PrintDlgPreview, ImageID(\PreviewImage))

  EndWith
  
EndProcedure

; Callback für Druck-Dialog
Procedure PrintDialogProc(hWnd, uMsg, wParam, lParam)

  Select uMsg
  
    ; Initialisierung
    Case #WM_INITDIALOG
      
      ; Fenstertitel
      SetWindowText_(hWnd, "Druckvorschau")
      
      ; Gadgets
      OldWindowID = UseGadgetList(hWnd)
      FrameGadget    (#Frame_PrintDlgPreview,                5,   5, 300, 300, "", #PB_Frame_Single)
      ImageGadget    (#Image_PrintDlgPreview, 10+(#PrintPreviewImageMaximumWidth-PrintDialogValues\PreviewImageWidth)/2, 10+(#PrintPreviewImageMaximumHeight-PrintDialogValues\PreviewImageHeight)/2, PrintDialogValues\PreviewImageWidth, PrintDialogValues\PreviewImageHeight, ImageID(PrintDialogValues\PreviewImage))
      ScrollBarGadget(#ScrollBar_PrintDlgHorizontalOffset,   5, 305, 300,  20, 0, 0, 0)
      ScrollBarGadget(#ScrollBar_PrintDlgVerticalOffset,   305,   5,  20, 300, 0, 0, 0, #PB_ScrollBar_Vertical)
      TextGadget     (#Text_PrintDlgZoomLabel,               5, 355, 110,  20, "", #PB_Text_Center)
      TrackBarGadget (#TrackBar_PrintDlgZoom,                5, 330, 320,  20, 0, 99)
        SetGadgetState(#TrackBar_PrintDlgZoom, 49)
      ButtonGadget   (#Button_PrintDlgPrint,               120, 355, 100,  20, "Drucken")
      ButtonGadget   (#Button_PrintDlgCancel,              225, 355, 100,  20, "Abbrechen")
      UseGadgetList(OldWindowID)
      
      PrintDialogUpdateZoom()
      PrintDialogUpdatePreview()
      
      ProcedureReturn #False
    
    Case #WM_HSCROLL
    
      Select lParam
      
        ; Horizontaler Offset
        Case GadgetID(#ScrollBar_PrintDlgHorizontalOffset)
          With ScrInfo.SCROLLINFO
            \cbSize = SizeOf(SCROLLINFO)
            \fMask = #SIF_ALL
            GetScrollInfo_(GadgetID(#ScrollBar_PrintDlgHorizontalOffset), #SB_CTL, @ScrInfo)
            Select wParam & $FFFF
              Case #SB_LINELEFT : \nPos - 1
              Case #SB_LINERIGHT : \nPos + 1
              Case #SB_PAGELEFT : \nPos - \nPage
              Case #SB_PAGERIGHT : \nPos + \nPage
              Case #SB_THUMBTRACK : \nPos = \nTrackPos
            EndSelect
            \fMask = #SIF_POS
            SetScrollInfo_(GadgetID(#ScrollBar_PrintDlgHorizontalOffset), #SB_CTL, @ScrInfo, #True)
          EndWith
          PrintDialogUpdateOffset()
          PrintDialogUpdatePreview()
          ProcedureReturn #True
        
        ; Zoom
        Case GadgetID(#TrackBar_PrintDlgZoom)
          PrintDialogUpdateZoom()
          PrintDialogUpdatePreview()
          ProcedureReturn #True
          
      EndSelect
      
    Case #WM_VSCROLL
    
      Select lParam
      
        ; Vertikaler Offset
        Case GadgetID(#ScrollBar_PrintDlgVerticalOffset)
          With ScrInfo.SCROLLINFO
            \cbSize = SizeOf(SCROLLINFO)
            \fMask = #SIF_ALL
            GetScrollInfo_(GadgetID(#ScrollBar_PrintDlgVerticalOffset), #SB_CTL, @ScrInfo)
            Select wParam & $FFFF
              Case #SB_LINEUP : \nPos - 1
              Case #SB_LINEDOWN : \nPos + 1
              Case #SB_PAGEUP : \nPos - \nPage
              Case #SB_PAGEDOWN : \nPos + \nPage
              Case #SB_THUMBTRACK : \nPos = \nTrackPos
            EndSelect
            \fMask = #SIF_POS
            SetScrollInfo_(GadgetID(#ScrollBar_PrintDlgVerticalOffset), #SB_CTL, @ScrInfo, #True)
          EndWith
          PrintDialogUpdateOffset()
          PrintDialogUpdatePreview()
          ProcedureReturn #True
          
      EndSelect
      
    Case #WM_COMMAND
    
      Select wParam >> 16

        Case #BN_CLICKED
        
          Select wParam & $FFFF

            ; Button "Drucken"
            Case #Button_PrintDlgPrint
              EndDialog_(hWnd, #True)
              ProcedureReturn #True
            
            ; Button "Abbrechen"
            Case #Button_PrintDlgCancel
              EndDialog_(hWnd, #False)
              ProcedureReturn #True
              
          EndSelect
          
      EndSelect

    ; Schließen
    Case #WM_CLOSE
      EndDialog_(hWnd, #False)
      ProcedureReturn #True
    
  EndSelect
  
  ProcedureReturn #False
  
EndProcedure

; Druck-Dialog mit Vorschau
; Element in MDIWindow() muss selektiert sein
Procedure PrintDialog()
    
  With PrintDialogValues
  
    If PrintRequester()
    
      ; Papiergröße
      \PageWidth = PrinterPageWidth()
      \PageHeight = PrinterPageHeight()
      
      ; Größe des Vorschaubildes
      If 1.0 * \PageWidth / \PageHeight > 1.0 * #PrintPreviewImageMaximumWidth / #PrintPreviewImageMaximumHeight
        \PreviewImageWidth = #PrintPreviewImageMaximumWidth
        \PreviewImageHeight = \PreviewImageWidth * \PageHeight / \PageWidth
      Else
        \PreviewImageHeight = #PrintPreviewImageMaximumHeight
        \PreviewImageWidth = \PreviewImageHeight * \PageWidth / \PageHeight
      EndIf
      
      ; Maximale Größe des Diagramms
      If 1.0 * MDIWindow()\DSOData\HorDivs / MDIWindow()\DSOData\VertDivs > 1.0 * \PageWidth / \PageHeight
        \MaximumDiagramWidth = \PageWidth
        \MaximumDiagramHeight = \MaximumDiagramWidth * MDIWindow()\DSOData\VertDivs / MDIWindow()\DSOData\HorDivs
      Else
        \MaximumDiagramHeight = \PageHeight
        \MaximumDiagramWidth = \MaximumDiagramHeight * MDIWindow()\DSOData\HorDivs / MDIWindow()\DSOData\VertDivs
      EndIf

      ; Vorschaubild erstellen
      \PreviewImage = CreateImage(#PB_Any, \PreviewImageWidth, \PreviewImageHeight)
      If \PreviewImage
      
        ; Dialog-Template erstellen
        PrintDialog.DLGTEMPLATE2\style = #WS_POPUP | #WS_BORDER | #WS_SYSMENU | #WS_CAPTION | #DS_MODALFRAME | #DS_CENTER
        PrintDialog\cx = PixelsToDialogTemplateUnitsX(330)
        PrintDialog\cy = PixelsToDialogTemplateUnitsY(380)
        
        ; Dialog anzeigen
        If DialogBoxIndirectParam_(GetModuleHandle_(#Null), @PrintDialog, WindowID(#Window_Main), @PrintDialogProc(), 0)
          If StartPrinting(GetFilePart(MDIWindow()\DSOData\FileName, #PB_FileSystem_NoExtension)+" - "+#AppName)
            DrawWaveform(@MDIWindow()\DSOData, PrinterOutput(), \DiagramWidth, \DiagramHeight, MDIWindow()\DisplayOffset, MDIWindow()\DisplayLength, 1, 0, 1, 1, 1, \DiagramX, \DiagramY)
            StopPrinting()
          EndIf
        EndIf
        
        ; Vorschaubild freigeben
        FreeImage(\PreviewImage)
        
      EndIf
      
    EndIf
         
  EndWith
  
EndProcedure

; Diverse Prozeduren für Math-Dialog
Procedure MathDialogUpdateOffset()
  
  With MathDialogValues
  
    ; Offset übernehmen
    \Offset = (GetGadgetState(#TrackBar_MathDlgOffset) - 100) * (MDIWindow()\DSOData\VertDivs / 2) / 100
    SetGadgetText(#Text_MathDlgOffsetLabel, QuickFormatString("Offset: {0} DIV", #FormatString_Double, @\Offset))
    
  EndWith
  
EndProcedure
Procedure MathDialogUpdateVoltPerDiv()
  
  With MathDialogValues
  
    ; Ablenkfaktor übernehmen
    Item = GetGadgetState(#ComboBox_MathDlgVoltPerDivValue)
    If Item > -1
      \VoltPerDiv = GetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, Item)
    Else
      \VoltPerDiv = ValDSIPrefix(Trim(GetGadgetText(#ComboBox_MathDlgVoltPerDivValue)))
      If \VoltPerDiv < 0
        \VoltPerDiv = 0
      EndIf
    EndIf
    Item = GetGadgetState(#ComboBox_MathDlgVoltPerDivUnit)
    If Item > -1
      \VoltPerDiv * Pow(10, GetGadgetItemData(#ComboBox_MathDlgVoltPerDivUnit, Item))
    EndIf
    
    ; Bei Autorange nicht benötigte Gadgets deaktivieren
    If \VoltPerDiv = 0
      State = 1
    Else
      State = 0
    EndIf
    DisableGadget(#ComboBox_MathDlgVoltPerDivUnit, State)
    DisableGadget(#TrackBar_MathDlgOffset, State)
    
  EndWith
  
EndProcedure

; Callback für Math-Dialog
Procedure MathDialogProc(hWnd, uMsg, wParam, lParam)

  Select uMsg
  
    ; Initialisierung
    Case #WM_INITDIALOG
    
      ; Fenstertitel
      SetWindowText_(hWnd, "Mathematik")
      
      ; Gadgets
      OldWindowID = UseGadgetList(hWnd)
      TextGadget    (#Text_MathDlgFirstChannelLabel,     5,   5, 100,  20, "Operand x:")
      ComboBoxGadget(#ComboBox_MathDlgFirstChannel,    110,   5, 175,  20, #PB_ComboBox_Editable)
      TextGadget    (#Text_MathDlgOperationLabel,        5,  30, 100,  20, "Operation:")
      ComboBoxGadget(#ComboBox_MathDlgOperation,       110,  30, 175,  20)
      TextGadget    (#Text_MathDlgSecondChannelLabel,    5,  55, 100,  20, "Operand y:")
      ComboBoxGadget(#ComboBox_MathDlgSecondChannel,   110,  55, 175,  20, #PB_ComboBox_Editable)
      TextGadget    (#Text_MathDlgVoltPerDivLabel,       5,  80, 100,  20, "Ablenkfaktor:")
      ComboBoxGadget(#ComboBox_MathDlgVoltPerDivValue, 110,  80,  85,  20, #PB_ComboBox_Editable)
      ComboBoxGadget(#ComboBox_MathDlgVoltPerDivUnit,  200,  80,  85,  20)
      TextGadget    (#Text_MathDlgOffsetLabel,           5, 105, 100,  20, "")
      TrackBarGadget(#TrackBar_MathDlgOffset,          110, 105, 175,  20, 0, 200)
        SetGadgetState(#TrackBar_MathDlgOffset, 100)
      ButtonGadget  (#Button_MathDlgDisable,             5, 130,  90,  20, "Deaktivieren")
      ButtonGadget  (#Button_MathDlgOK,                100, 130,  90,  20, "OK")
      ButtonGadget  (#Button_MathDlgCancel,            195, 130,  90,  20, "Abbrechen")
      UseGadgetList(OldWindowID)
      
      ; Kanalliste
      Item = 0
      For c = 0 To #DSO_LastChannelIndex
        If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
          ChannelName$ = MakeChannelName(c)
          AddGadgetItem    (#ComboBox_MathDlgFirstChannel,  Item, ChannelName$)
          SetGadgetItemData(#ComboBox_MathDlgFirstChannel,  Item, c)
          AddGadgetItem    (#ComboBox_MathDlgSecondChannel, Item, ChannelName$)
          SetGadgetItemData(#ComboBox_MathDlgSecondChannel, Item, c)
          Item + 1
        EndIf
      Next
      SetGadgetState(#ComboBox_MathDlgFirstChannel, 0)
      SetGadgetState(#ComboBox_MathDlgSecondChannel, 0)
      
      ; Operatorliste
      AddGadgetItem    (#ComboBox_MathDlgOperation, 0, "x+y")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 0, #DSOMath_Add)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 1, "x-y")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 1, #DSOMath_Subtract)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 2, "x*y")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 2, #DSOMath_Multiply)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 3, "x/y")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 3, #DSOMath_Divide)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 4, "1/x")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 4, #DSOMath_Reciprocal)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 5, "x²")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 5, #DSOMath_Square)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 6, "sqrt(x)")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 6, #DSOMath_Sqrt)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 7, "abs(x)")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 7, #DSOMath_Abs)
      AddGadgetItem    (#ComboBox_MathDlgOperation, 8, "-x")
      SetGadgetItemData(#ComboBox_MathDlgOperation, 8, #DSOMath_Invert)
      SetGadgetState(#ComboBox_MathDlgOperation, 0)
      
      ; Ablenkfaktor-Werteliste
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 0, "Auto")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 0, 0)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 1, "1")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 1, 1)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 2, "2")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 2, 2)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 3, "5")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 3, 5)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 4, "10")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 4, 10)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 5, "20")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 5, 20)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 6, "50")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 6, 50)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 7, "100")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 7, 100)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 8, "200")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 8, 200)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivValue, 9, "500")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivValue, 9, 500)
      SetGadgetState(#ComboBox_MathDlgVoltPerDivValue, 0)
      
      ; Ablenkfaktor-Einheitenliste
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivUnit, 0, "µV/DIV")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivUnit, 0, -6)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivUnit, 1, "mV/DIV")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivUnit, 1, -3)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivUnit, 2, "V/DIV")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivUnit, 2, 0)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivUnit, 3, "kV/DIV")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivUnit, 3, 3)
      AddGadgetItem    (#ComboBox_MathDlgVoltPerDivUnit, 4, "MV/DIV")
      SetGadgetItemData(#ComboBox_MathDlgVoltPerDivUnit, 4, 6)
      SetGadgetState(#ComboBox_MathDlgVoltPerDivUnit, 2)
      
      MathDialogUpdateVoltPerDiv()
      MathDialogUpdateOffset()
      
      ProcedureReturn #False
      
    Case #WM_HSCROLL
    
      Select lParam
    
        ; TrackBar_MathDlgOffset
        Case GadgetID(#TrackBar_MathDlgOffset)
          MathDialogUpdateOffset()
          ProcedureReturn #True
          
      EndSelect
          
    Case #WM_COMMAND
    
      Select wParam >> 16
        
        Case #CBN_SELCHANGE, #CBN_EDITCHANGE
        
          Select wParam & $FFFF
          
            ; ComboBox_MathDlgVoltPerDivValue, ComboBox_MathDlgVoltPerDivUnit
            Case #ComboBox_MathDlgVoltPerDivValue, #ComboBox_MathDlgVoltPerDivUnit
              MathDialogUpdateVoltPerDiv()
              ProcedureReturn #True
              
          EndSelect
          
        Case #BN_CLICKED
        
          Select wParam & $FFFF

            ; Button "OK"
            Case #Button_MathDlgOK
              With MathDialogValues
                Item = GetGadgetState(#ComboBox_MathDlgOperation)
                If Item > -1 ; Operation ausgewählt
                  \Operation = GetGadgetItemData(#ComboBox_MathDlgOperation, Item)
                  Item = GetGadgetState(#ComboBox_MathDlgFirstChannel)
                  If Item > -1 ; Kanal ausgewählt
                    \xOperand = GetGadgetItemData(#ComboBox_MathDlgFirstChannel, Item)
                  Else ; Wert eingegeben
                    \xOperand = #DSOMath_Value
                    \x = ValDSIPrefix(Trim(GetGadgetText(#ComboBox_MathDlgFirstChannel)))
                  EndIf
                  Item = GetGadgetState(#ComboBox_MathDlgSecondChannel)
                  If Item > -1 ; Kanal ausgewählt
                    \yOperand = GetGadgetItemData(#ComboBox_MathDlgSecondChannel, Item)
                  Else ; Wert direkt eingegeben
                    \yOperand = #DSOMath_Value
                    \y = ValDSIPrefix(Trim(GetGadgetText(#ComboBox_MathDlgSecondChannel)))
                  EndIf
                  EndDialog_(hWnd, #True)
                EndIf
              EndWith
              ProcedureReturn #True
        
            ; Button "Abbrechen"
            Case #Button_MathDlgCancel
              EndDialog_(hWnd, #False)
              ProcedureReturn #True
        
            ; Button "Deaktivieren"
            Case #Button_MathDlgDisable
              MathDialogValues\Operation = #DSOMath_Disable
              EndDialog_(hWnd, #True)
              ProcedureReturn #True
              
          EndSelect
          
      EndSelect

  ; Schließen
  Case #WM_CLOSE
    EndDialog_(hWnd, #False)
    ProcedureReturn #True
    
  EndSelect
  
  ProcedureReturn #False
  
EndProcedure

; Mathematik-Dialog
; Element in MDIWindow() muss selektiert sein!
Procedure MathDialog()

  ; Dialog-Template erstellen
  With MathDialog.DLGTEMPLATE2
    \style = #WS_POPUP | #WS_BORDER | #WS_SYSMENU | #WS_CAPTION | #DS_MODALFRAME | #DS_CENTER
    \cx = PixelsToDialogTemplateUnitsX(290)
    \cy = PixelsToDialogTemplateUnitsY(155)
  EndWith
  
  ; Dialog anzeigen
  If DialogBoxIndirectParam_(GetModuleHandle_(#Null), @MathDialog, WindowID(#Window_Main), @MathDialogProc(), 0)
    With MathDialogValues
      DSOMath(@MDIWindow()\DSOData, \Operation, \xOperand, \yOperand, \VoltPerDiv, \Offset, \x, \y)
    EndWith
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
  
EndProcedure

; Geräteeinstellungen in MDIWindow aktualisieren
; Element in MDIWindow() muss selektiert sein!
Procedure UpdateSettings()
  
  With MDIWindow()
    
    ; Icons für Kanäle definieren
    Dim ChannelImage(#DSO_LastCHIndex)
    ChannelImage(#DSO_CH1) = #Image_ch1
    ChannelImage(#DSO_CH2) = #Image_ch2
;     ChannelImage(#DSO_CH3) = ImageID(#Image_ch3)
;     ChannelImage(#DSO_CH4) = ImageID(#Image_ch4)
  
    ; TreeGadget leeren
    ClearGadgetItems(\Tree_Settings)
    
    ; Kanäle
    For c = 0 To #DSO_LastCHIndex
      
      If \DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On ; Kanal aktiv
      
        ; Kanalüberschrift
        AddGadgetItem(\Tree_Settings, -1, MakeChannelName(c), ImageID(ChannelImage(c)), 0)
        Item = CountGadgetItems(\Tree_Settings) - 1
          
          ; Ablenkfaktor
          If \DSOData\ChannelShow[c] & #DSO_ChannelShow_VoltPerDiv
            AddGadgetItem(\Tree_Settings, -1, QuickFormatString("{0Sd5}V/DIV", #FormatString_Double, @\DSOData\ChannelVoltPerDiv[c]), ImageID(#Image_chvolt), 1)
          EndIf
    
          ; Kopplung
          If \DSOData\ChannelShow[c] & #DSO_ChannelShow_Coupling
            Select \DSOData\ChannelCoupling[c]
              Case #DSO_ChannelCoupling_DC : Text$ = "DC" : Image = #Image_chcoupdc
              Case #DSO_ChannelCoupling_AC : Text$ = "AC" : Image = #Image_chcoupac
              Case #DSO_ChannelCoupling_GND : Text$ = "GND" : Image = #Image_chcoupgnd
            EndSelect
            AddGadgetItem(\Tree_Settings, -1, Text$, ImageID(Image), 1)
          EndIf
        
          ; Tastkopfteilung
          If \DSOData\ChannelShow[c] & #DSO_ChannelShow_ProbeAttenuation
            AddGadgetItem(\Tree_Settings, -1, QuickFormatString("{0}:1", #FormatString_Double, @\DSOData\ChannelProbeAttenuation[c]), ImageID(#Image_chprobe), 1)
          EndIf
          
          ; Invertierung
          If \DSOData\ChannelShow[c] & #DSO_ChannelShow_Invert And \DSOData\ChannelInvert[c] = #DSO_ChannelInvert_On
            AddGadgetItem(\Tree_Settings, -1, "Invertiert", ImageID(#Image_chinvert), 1)
          EndIf
          
          ; Bandbreitenbegrenzung
          If \DSOData\ChannelShow[c] & #DSO_ChannelShow_BandwidthLimit And \DSOData\ChannelBandwidthLimit[c] = #DSO_ChannelBandwidthLimit_On
            AddGadgetItem(\Tree_Settings, -1, "Bandbreitenbegrenzung (Bandwidth Limit)", ImageID(#Image_chbwlim), 1)
          EndIf
          
        ; Verzweigung öffnen
        SetGadgetItemState(\Tree_Settings, Item, #PB_Tree_Expanded)
          
      EndIf
  
    Next
    
    ; Zeitbasis
    If \DSOData\Show & #DSO_Show_TimePerDiv
      AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Zeitbasis: {0Sd5}s/DIV", #FormatString_Double, @\DSOData\TimePerDiv), ImageID(#Image_timediv), 0)
    EndIf
    
    If \DSOData\Show & (#DSO_Show_TriggerMode | #DSO_Show_TriggerSource | #DSO_Show_TriggerCoupling | #DSO_Show_TriggerLevel | #DSO_Show_TriggerOffset | #DSO_Show_TriggerType | #DSO_Show_TriggerSlope | #DSO_Show_TriggerPolarity | #DSO_Show_TriggerWhen | #DSO_Show_TriggerPulseWidth) ; Mindestens eine Triggereinstellung soll angezeigt werden
  
      ; Triggerüberschrift
      AddGadgetItem(\Tree_Settings, -1, "Trigger", ImageID(#Image_trig), 0)
      Item = CountGadgetItems(\Tree_Settings) - 1
      
        ; Triggermodus
        If \DSOData\Show & #DSO_Show_TriggerMode
          Select \DSOData\TriggerMode
            Case #DSO_TriggerMode_Auto : Text$ = "Auto" : Image = #Image_trigauto
            Case #DSO_TriggerMode_Normal : Text$ = "Normal" : Image = #Image_trignorm
            Case #DSO_TriggerMode_Single : Text$ = "Single" : Image = #Image_trigsingle
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Modus: {0}", #FormatString_String, @Text$), ImageID(Image), 1)
        EndIf
        
        ; Triggerquelle
        If \DSOData\Show & #DSO_Show_TriggerSource
          Select \DSOData\TriggerSource
            Case #DSO_TriggerSource_Channel : Text$ = MakeChannelName(\DSOData\TriggerSourceChannel) : Image = ChannelImage(\DSOData\TriggerSourceChannel)
            Case #DSO_TriggerSource_EXT : Text$ = "Extern" : Image = #Image_trigsourceext
            Case #DSO_TriggerSource_ACLine : Text$ = "Netzfrequenz (AC Line)" : Image = #Image_trigsourceline
            Case #DSO_TriggerSource_Alternate : Text$ = "Alternierend (Alter)" : Image = #Image_trigsourcealter
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Quelle: {0}", #FormatString_String, @Text$), ImageID(Image), 1)
        EndIf
        
        ; Triggerkopplung
        If \DSOData\Show & #DSO_Show_TriggerCoupling
          Select \DSOData\TriggerCoupling
            Case #DSO_TriggerCoupling_DC : Text$ = "DC" : Image = #Image_chcoupdc
            Case #DSO_TriggerCoupling_AC : Text$ = "AC" : Image = #Image_chcoupac
            Case #DSO_TriggerCoupling_HFReject : Text$ = "Tiefpass (HF Reject)" : Image = #Image_trigcouphfrej
            Case #DSO_TriggerCoupling_LFReject : Text$ = "Hochpass (LF Reject)" : Image = #Image_trigcouplfrej
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Kopplung: {0}", #FormatString_String, @Text$), ImageID(Image), 1)
        EndIf
        
        ; Triggerlevel
        If \DSOData\Show & #DSO_Show_TriggerLevel
          AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Triggerlevel: {0Sd5}V", #FormatString_Double, @\DSOData\TriggerLevel), ImageID(#Image_triglevel), 1)
        EndIf
    
        ; Triggeroffset
        If \DSOData\Show & #DSO_Show_TriggerOffset
          AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Triggeroffset: {0Sd5}s", #FormatString_Double, @\DSOData\TriggerOffset), ImageID(#Image_trigoffset), 1)
        EndIf
      
        ; Triggertyp
        If \DSOData\Show & #DSO_Show_TriggerType
          Select \DSOData\TriggerType
            Case #DSO_TriggerType_Edge : Text$ = "Flankentriggerung (Edge)" : Image = #Image_trigtypeedge
            Case #DSO_TriggerType_Pulse : Text$ = "Pulsbreitentriggerung (Pulse)" : Image = #Image_trigtypepulse
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, Text$, ImageID(Image), 1)
        EndIf
                
        ; Triggerflanke
        If \DSOData\Show & #DSO_Show_TriggerSlope
          Select \DSOData\TriggerSlope
            Case #DSO_TriggerSlope_Rise : Text$ = "Steigende Flanke (Rise)" : Image = #Image_trigsloperise
            Case #DSO_TriggerSlope_Fall : Text$ = "Fallende Flanke (Fall)" : Image = #Image_trigslopefall
            Case #DSO_TriggerSlope_RiseFall : Text$ = "Steigende und fallende Flanke (Rise & Fall)" : Image = #Image_trigsloperisefall
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, Text$, ImageID(Image), 1)
        EndIf
          
        ; Triggerpolarität
        If \DSOData\Show & #DSO_Show_TriggerPolarity
          Select \DSOData\TriggerPolarity
            Case #DSO_TriggerPolarity_Positive : Text$ = "ON-Zeit (Positive)" : Image = #Image_trigpolaritypos
            Case #DSO_TriggerPolarity_Negative : Text$ = "OFF-Zeit (Negative)" : Image = #Image_trigpolarityneg
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, Text$, ImageID(Image), 1)
        EndIf
            
        ; Trigger ><=
        If \DSOData\Show & #DSO_Show_TriggerWhen
          Select \DSOData\TriggerWhen
            Case #DSO_TriggerWhen_Greater : Text$ = "Größer (>)" : Image = #Image_triggreater
            Case #DSO_TriggerWhen_Lesser : Text$ = "Kleiner (<)" : Image = #Image_triglesser
            Case #DSO_TriggerWhen_Equal : Text$ = "Gleich (=)" : Image = #Image_trigequal
          EndSelect
          AddGadgetItem(\Tree_Settings, -1, Text$, ImageID(Image), 1)
        EndIf
            
        ; Triggerpulsbreite
        If \DSOData\Show & #DSO_Show_TriggerPulseWidth
          AddGadgetItem(\Tree_Settings, -1, QuickFormatString("Pulsbreite: {0Sd5}s", #FormatString_Double, @\DSOData\TriggerPulseWidth), ImageID(#Image_trigpulsewidth), 1)
        EndIf
  
      ; Verzweigung öffnen
      SetGadgetItemState(\Tree_Settings, Item, #PB_Tree_Expanded)
      
    EndIf
    
  EndWith
  
EndProcedure

; Cursor 1 auf ersten und Cursor 2 auf letzten Datenpunkt setzen
; Element in MDIWindow() muss selektiert sein!
Macro ResetCursors()
  MDIWindow()\Cursor1 = 0
  MDIWindow()\Cursor2 = MDIWindow()\DSOData\PointsPerChannel - 1
EndMacro

; Cursordaten in MDIWindow aktualisieren
; Element in MDIWindow() muss selektiert sein!
Procedure UpdateCursorData()
  
  With MDIWindow()
    
    If \EnableCursors
    
      ; Spannung
      For c = 0 To #DSO_LastChannelIndex
        If \DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
          Cursor1Volt.d = DataPointVoltage(@\DSOData, c, MDIWindow()\Cursor1)
          Cursor2Volt.d = DataPointVoltage(@\DSOData, c, MDIWindow()\Cursor2)
          VoltDiff.d = Cursor1Volt - Cursor2Volt
          ChannelName$ = MakeChannelName(c)
          Text1$ + QuickFormatString("{0}: {1Sd5}V", #FormatString_String, @ChannelName$, #FormatString_Double, @Cursor1Volt) + #CRLF$
          Text2$ + QuickFormatString("{0}: {1Sd5}V", #FormatString_String, @ChannelName$, #FormatString_Double, @Cursor2Volt) + #CRLF$
          TextDiff$ + QuickFormatString("{0}: {1Sd5}V", #FormatString_String, @ChannelName$, #FormatString_Double, @VoltDiff) + #CRLF$
        EndIf
      Next
      
      ; Zeit
      Cursor1Time.d = DataPointTime(@\DSOData, MDIWindow()\Cursor1)
      Cursor2Time.d = DataPointTime(@\DSOData, MDIWindow()\Cursor2)
      TimeDiff.d = Cursor1Time - Cursor2Time
      Text1$ + QuickFormatString("Zeit: {0Sd5}s", #FormatString_Double, @Cursor1Time)
      Text2$ + QuickFormatString("Zeit: {0Sd5}s", #FormatString_Double, @Cursor2Time)
      TextDiff$ + QuickFormatString("Zeit: {0Sd5}s", #FormatString_Double, @TimeDiff)
      If TimeDiff <> 0
        Freq.d = 1 / Abs(TimeDiff)
        TextDiff$ + #CRLF$ + QuickFormatString("Frq.: {0Sd5}Hz", #FormatString_Double, @Freq)
      EndIf
      
      ; Ausgabe
      SetGadgetText(\Editor_Cursor1Data, Text1$)
      SetGadgetText(\Editor_Cursor2Data, Text2$)
      SetGadgetText(\Editor_CursorDiffData, TextDiff$)
      
    EndIf
  
  EndWith
  
EndProcedure

; Cursor-Messung durchführen
; Element in MDIWindow() muss selektiert sein!
Enumeration
  #CursorMeasurement_Peak
  #CursorMeasurement_RMS
  #CursorMeasurement_Mean
EndEnumeration
Procedure CursorMeasurement(Type)
    
  ; Anfang, Ende und Länge des Datenbereichs ermitteln
  FirstDataPoint = MDIWindow()\Cursor1
  LastDataPoint = MDIWindow()\Cursor2
  If FirstDataPoint > LastDataPoint
    Swap FirstDataPoint, LastDataPoint
  EndIf
  DataPointCount = 1 + LastDataPoint - FirstDataPoint

  Select Type
  
    Case #CursorMeasurement_Peak ; Spitzenwerte
    
      Volt.d
      Min.d
      Max.d
      PeakToPeak.d
      Text$ = "Spitzenwerte (Minimum, Maximum, Spitze-Spitze)"
      For c = 0 To #DSO_LastChannelIndex
        If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
          For n = FirstDataPoint To LastDataPoint
            Volt = DataPointVoltage(@MDIWindow()\DSOData, c, n)
            If n = FirstDataPoint
              Min = Volt
              Max = Volt
            ElseIf Volt < Min
              Min = Volt
            ElseIf Volt > Max
              Max = Volt
            EndIf
          Next
          PeakToPeak = Max - Min
          ChannelName$ = MakeChannelName(c)
          Text$ + #CRLF$ + QuickFormatString("{0}: {1Sd5}V, {2Sd5}V, {3Sd5}V", #FormatString_String, @ChannelName$, #FormatString_Double, @Min, #FormatString_Double, @Max, #FormatString_Double, @PeakToPeak)
        EndIf
      Next

    Case #CursorMeasurement_RMS ; Effektivwerte
      
      RMS.d
      Text$ = "Effektivwerte"
      For c = 0 To #DSO_LastChannelIndex
        If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
          RMS = 0
          For n = FirstDataPoint To LastDataPoint
            RMS + Pow(DataPointVoltage(@MDIWindow()\DSOData, c, n), 2) / DataPointCount
          Next
          RMS = Sqr(RMS)
          ChannelName$ = MakeChannelName(c)
          Text$ + #CRLF$ + QuickFormatString("{0}: {1Sd5}V", #FormatString_String, @ChannelName$, #FormatString_Double, @RMS)
        EndIf
      Next
      
    Case #CursorMeasurement_Mean ; Mittelwerte
      
      Mean.d
      Text$ = "Mittelwerte"
      For c = 0 To #DSO_LastChannelIndex
        If MDIWindow()\DSOData\ChannelEnable[c] = #DSO_ChannelEnable_On
          Mean = 0
          For n = FirstDataPoint To LastDataPoint
            Mean + DataPointVoltage(@MDIWindow()\DSOData, c, n) / DataPointCount
          Next
          ChannelName$ = MakeChannelName(c)
          Text$ + #CRLF$ + QuickFormatString("{0}: {1Sd5}V", #FormatString_String, @ChannelName$, #FormatString_Double, @Mean)
        EndIf
      Next
     
  EndSelect
  
  ; Ausgabe der Ergebnisse
  SetGadgetText(MDIWindow()\Editor_CursorMeasurementData, Text$)
  
EndProcedure

; Datenpunkt anhand der X-Koordinate in Canvas_Waveform ermitteln
; Element in MDIWindow() muss selektiert sein!
Macro WaveformCanvasCoordinateToDataPoint(x)
  (MDIWindow()\DisplayOffset + ((x) * MDIWindow()\DisplayLength / MDIWindow()\WaveformCanvasWidth))
EndMacro

; MDIWindow aktualisieren
; Element in MDIWindow() muss selektiert sein!
#UpdateMDIWindow_ScrollBar_Offset       = $0001 ; Ereignis auf MDIWindow()\ScrollBar_Offset
#UpdateMDIWindow_DisplayOffset          = $0002 ; MDIWindow()\DisplayOffset wurde verändert
#UpdateMDIWindow_TrackBar_Zoom          = $0004 ; Ereignis auf MDIWindow()\TrackBar_Zoom
#UpdateMDIWindow_DisplayLength          = $0008 ; MDIWindow()\DisplayLength wurde verändert
#UpdateMDIWindow_CheckBox_EnableCursors = $0010 ; Ereignis auf MDIWindow()\CheckBox_EnableCursors
#UpdateMDIWindow_EnableCursors          = $0020 ; MDIWindow()\EnableCursors wurde verändert
#UpdateMDIWindow_Cursor                 = $0040 ; MDIWindow()\Cursor... wurde verändert
#UpdateMDIWindow_DSOData_MathChannel    = $0080 ; Es wurden den Math-Kanal betreffende Werte in MDIWindow()\DSOData geändert
#UpdateMDIWindow_DSOData                = $0100 ; Es wurden irgendwelche Werte in MDIWindow()\DSOData geändert
#UpdateMDIWindow_WaveformCanvasSize     = $0200
Procedure UpdateMDIWindow()
  
  With MDIWindow()
    
    ; Eingabe
    
    ; ScrollBar_Offset einlesen
    If \Update & #UpdateMDIWindow_ScrollBar_Offset
      \DisplayOffset = GetGadgetState(\ScrollBar_Offset)
      \Update | #UpdateMDIWindow_DisplayOffset
    EndIf
    
    ; TrackBar_Zoom einlesen
    If \Update & (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_TrackBar_Zoom)
      \OldDisplayLength = \DisplayLength
      \DisplayLength = \DSOData\PointsPerChannel * ZoomFactor(GetGadgetState(\TrackBar_Zoom)) / 100
      \Update | #UpdateMDIWindow_DisplayLength
    EndIf
    
    ; CheckBox_EnableCursors einlesen
    If \Update & #UpdateMDIWindow_CheckBox_EnableCursors
      \EnableCursors = Bool(GetGadgetState(\CheckBox_EnableCursors) = #PB_Checkbox_Checked)
      \Update | #UpdateMDIWindow_EnableCursors
    EndIf
    
    ; Verarbeitung

    ; Cursor zurücksetzem
    If \Update & #UpdateMDIWindow_DSOData
      ResetCursors()
      \Update | #UpdateMDIWindow_Cursor
    EndIf
    
    ; Größe von WaveformCanvas berechnen
    If \Update & #UpdateMDIWindow_DSOData
      If 1.0 * \DSOData\HorDivs / \DSOData\VertDivs > 1.0 * #WaveformCanvasMaximumWidth / #WaveformCanvasMaximumHeight
        \WaveformCanvasWidth = #WaveformCanvasMaximumWidth
        \WaveformCanvasHeight = \WaveformCanvasWidth * \DSOData\VertDivs / \DSOData\HorDivs
      Else
        \WaveformCanvasHeight = #WaveformCanvasMaximumHeight
        \WaveformCanvasWidth = \WaveformCanvasHeight * \DSOData\HorDivs / \DSOData\VertDivs
      EndIf
      \Update | #UpdateMDIWindow_WaveformCanvasSize
    EndIf
    
    ; Größe von WaveformCanvas festlegen
    If \Update & #UpdateMDIWindow_WaveformCanvasSize
      ResizeGadget(\Canvas_Waveform, 5+(#WaveformCanvasMaximumWidth-\WaveformCanvasWidth)/2, 5+(#WaveformCanvasMaximumHeight-\WaveformCanvasHeight)/2, \WaveformCanvasWidth, \WaveformCanvasHeight)
    EndIf
    
    ; ScrollBar_Offset an Zoom anpassen
    If \Update & (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_DisplayLength)
      
      ; Bereich von SrollBar_Offset anpassen
      MaximumDisplayOffset = \DSOData\PointsPerChannel - \DisplayLength
      PageLength = \DisplayLength / 2
      SetGadgetAttribute(\ScrollBar_Offset, #PB_ScrollBar_Maximum, MaximumDisplayOffset+PageLength-1)
      SetGadgetAttribute(\ScrollBar_Offset, #PB_ScrollBar_PageLength, PageLength)
      
      ; Neuen Offset Berechnen
      \DisplayOffset + (\OldDisplayLength - \DisplayLength) / 2
      If \DisplayOffset < 0
        \DisplayOffset = 0
      EndIf
      If \DisplayOffset > MaximumDisplayOffset
        \DisplayOffset = MaximumDisplayOffset
      EndIf
      \Update | #UpdateMDIWindow_DisplayOffset
      
    EndIf
    
    ; Fenster an Modus anpassen
    If \Update & #UpdateMDIWindow_EnableCursors
      If \EnableCursors
        ResizeWindow(\Window, #PB_Ignore, #PB_Ignore, 815, 545)
        SetGadgetAttribute(\Canvas_Waveform, #PB_Canvas_Cursor, #PB_Cursor_Cross)
        State = 0
      Else
        ResizeWindow(\Window, #PB_Ignore, #PB_Ignore, 815, 445)
        SetGadgetAttribute(\Canvas_Waveform, #PB_Canvas_Cursor, #PB_Cursor_Default)
        State = 1
      EndIf
      DisableGadget(\Editor_Cursor1Data, State)
      DisableGadget(\Editor_Cursor2Data, State)
      DisableGadget(\Editor_CursorDiffData, State)
      DisableGadget(\Button_SelectAll, State)
      DisableGadget(\Button_CursorMeasurement, State)
      DisableGadget(\Editor_CursorMeasurementData, State)
      DisableGadget(\Button_MathFunctions, State)
    EndIf
    
    ; Ausgabe

    ; Ausgabe Fenstertitel
    If \Update & #UpdateMDIWindow_DSOData
      SetWindowTitle(\Window, GetFilePart(\DSOData\FileName))
    EndIf
    
    ; Ausgabe ScrollBar_Offset
    If \Update & #UpdateMDIWindow_DisplayOffset And Not \Update & #UpdateMDIWindow_ScrollBar_Offset
      SetGadgetState(\ScrollBar_Offset, \DisplayOffset)
    EndIf
    
    ; Ausgabe Geräteeinstellungen
    If \Update & #UpdateMDIWindow_DSOData
      UpdateSettings()
    EndIf
    
    ; Ausgabe Text_Zoom
    If \Update & (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_DisplayLength)
      TimePerDiv.d = \DSOData\TimePerDiv * \DisplayLength / \DSOData\PointsPerChannel
      SetGadgetText(\Text_Zoom, QuickFormatString("Zoom: {0Sd5}s/DIV", #FormatString_Double, @TimePerDiv))
    EndIf
    
    ; Ausgabe CheckBox_EnableCursors
    If \Update & #UpdateMDIWindow_EnableCursors And Not #UpdateMDIWindow_CheckBox_EnableCursors
      If \EnableCursors
        SetGadgetState(\CheckBox_EnableCursors, #PB_Checkbox_Checked)
      Else
        SetGadgetState(\CheckBox_EnableCursors, #PB_Checkbox_Unchecked)
      EndIf
    EndIf
    
    ; Ausgabe Cursorwerte
    If \Update & (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_DSOData_MathChannel | #UpdateMDIWindow_EnableCursors | #UpdateMDIWindow_Cursor)
      UpdateCursorData()
    EndIf
    
    ; Ausgabe Ablenkfaktor Math-Kanal
    If \Update & (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_DSOData_MathChannel)
      If \DSOData\ChannelEnable[#DSO_Math] = #DSO_ChannelEnable_On
        SetGadgetText(\Text_MathVoltPerDiv, QuickFormatString("Math: {0Sd5}V/DIV", #FormatString_Double, @\DSOData\ChannelVoltPerDiv[#DSO_Math]))
      Else
        SetGadgetText(\Text_MathVoltPerDiv, "")
      EndIf
    EndIf
    
    ; Ausgabe Diagramm
    If \Update & (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_DSOData_MathChannel | #UpdateMDIWindow_WaveformCanvasSize | #UpdateMDIWindow_DisplayOffset | #UpdateMDIWindow_DisplayLength | #UpdateMDIWindow_EnableCursors | #UpdateMDIWindow_Cursor)
      DrawWaveform(@\DSOData, CanvasOutput(\Canvas_Waveform), \WaveformCanvasWidth, \WaveformCanvasHeight, \DisplayOffset, \DisplayLength, 0, 1, 0, 0, 0, 0, 0, \EnableCursors, \Cursor1, \Cursor2)
    EndIf

    \Update = 0
  
  EndWith
  
EndProcedure

; Element in MDIWindow() anhand der Window-Nummer auswählen
Procedure SelectMDIWindow(Window)
  ForEach MDIWindow()
    If MDIWindow()\Window = Window
      ProcedureReturn #True
    EndIf
  Next
  ProcedureReturn #False
EndProcedure

; MDIWindow erstellen
Procedure CreateMDIWindow()
  If AddElement(MDIWindow())
    With MDIWindow()
      \Window = AddGadgetItem(#MDI_MainWnd, #PB_Any, "", 0, #PB_Window_SystemMenu|#PB_Window_Invisible)
      If \Window
        \Canvas_Waveform              = CanvasGadget   (#PB_Any,   5,   5, #WaveformCanvasMaximumWidth, #WaveformCanvasMaximumHeight)
        \ScrollBar_Offset             = ScrollBarGadget(#PB_Any,   5, 410, 600,  30, 0, 0, 0)
        \Tree_Settings                = TreeGadget     (#PB_Any, 610,   5, 200, 350)
        \CheckBox_EnableCursors       = CheckBoxGadget (#PB_Any, 610, 360, 200,  20, "Cursor anzeigen")
        \Text_Zoom                    = TextGadget     (#PB_Any, 610, 385, 200,  20, "", #PB_Text_Center)
        \TrackBar_Zoom                = TrackBarGadget (#PB_Any, 610, 410, 200,  30, 0, #ZoomFactorCount-1, #PB_TrackBar_Ticks)
        \Frame_Cursor1                = FrameGadget    (#PB_Any,   5, 445, 140,  95, "Cursor 1")
        \Editor_Cursor1Data           = EditorGadget   (#PB_Any,  10, 460, 130,  75, #PB_Editor_ReadOnly)
        \Frame_Cursor2                = FrameGadget    (#PB_Any, 150, 445, 140,  95, "Cursor 2")
        \Editor_Cursor2Data           = EditorGadget   (#PB_Any, 155, 460, 130,  75, #PB_Editor_ReadOnly)
        \Frame_CursorDiff             = FrameGadget    (#PB_Any, 295, 445, 140,  95, "Cursor 1 - Cursor 2")
        \Editor_CursorDiffData        = EditorGadget   (#PB_Any, 300, 460, 130,  75, #PB_Editor_ReadOnly)
        \Button_SelectAll             = ButtonGadget   (#PB_Any, 440, 445, 100,  20, "Alles auswählen")
        \Button_CursorMeasurement     = ButtonGadget   (#PB_Any, 440, 470, 100,  20, "Messung...")
        \Button_MathFunctions         = ButtonGadget   (#PB_Any, 440, 495, 100,  20, "Mathematik...")
        \Text_MathVoltPerDiv          = TextGadget     (#PB_Any, 435, 520, 110,  20, "", #PB_Text_Center)
        \Frame_CursorMeasurement      = FrameGadget    (#PB_Any, 545, 445, 265,  95, "Ergebnis")
        \Editor_CursorMeasurementData = EditorGadget   (#PB_Any, 550, 460, 255,  75, #PB_Editor_ReadOnly)
        ProcedureReturn #True
      EndIf
    EndWith
    DeleteElement(MDIWindow()) ; Element wieder entfernen, wenn Erstellen des Fensters fehlgeschlagen
  EndIf
  ProcedureReturn #False
EndProcedure

; MDIWindow entfernen und alle damit verbundenen Ressourcen freigeben
; Element in MDIWindow() muss selektiert sein!
Procedure DestroyMDIWindow()
  FreeDSOData(@MDIWindow()\DSOData)
  CloseWindow(MDIWindow()\Window)
  DeleteElement(MDIWindow())
EndProcedure

; Datei laden
Procedure LoadFile(FileName$)
  If CreateMDIWindow()
    Select ReadDSODataFile(@MDIWindow()\DSOData, FileName$)
      Case #ReadDSODataFile_Success
        MDIWindow()\Update | (#UpdateMDIWindow_DSOData | #UpdateMDIWindow_EnableCursors)
        UpdateMDIWindow()
        HideWindow(MDIWindow()\Window, #False)
        ProcedureReturn #True
      Case #ReadDSODataFile_MemoryError
        ErrorMessage(QuickFormatString("Datei "+#DQUOTE$+"{0}"+#DQUOTE$+": Speicher für Kanal-Daten konnte nicht reserviert werden!", #FormatString_String, @FileName$))
      Case #ReadDSODataFile_FormatError
        ErrorMessage(QuickFormatString("Datei "+#DQUOTE$+"{0}"+#DQUOTE$+": Unbekanntes Format!", #FormatString_String, @FileName$))
      Case #ReadDSODataFile_IncorrectValueError
        ErrorMessage(QuickFormatString("Datei "+#DQUOTE$+"{0}"+#DQUOTE$+": Unzulässige Werte gefunden!", #FormatString_String, @FileName$))
      Case #ReadDSODataFile_NoFileError
        ErrorMessage(QuickFormatString("Die Datei "+#DQUOTE$+"{0}"+#DQUOTE$+" kann nicht geöffnet werden!", #FormatString_String, @FileName$))
    EndSelect
    DestroyMDIWindow() ; Fenster wieder entfernen, wenn Laden der Datei fehlgeschlagen
  EndIf
  ProcedureReturn #False
EndProcedure



; ########################################
;- Programmanfang
; ########################################

; PNG-Encoder einbinden
UsePNGImageEncoder()

; Eigenen Pfad ermitteln
CompilerIf #PB_Editor_CreateExecutable
  SelfPath$ = GetPathPart(ProgramFilename())
CompilerElse
  SelfPath$ = #PB_Compiler_FilePath + "..\"
CompilerEndIf

;- Hauptfenster
If OpenWindow(#Window_Main, #PB_Ignore, #PB_Ignore, 800, 600, #AppName, #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Maximize)
  
  ; Drag&Drop aktivieren
  EnableWindowDrop(#Window_Main, #PB_Drop_Files, #PB_Drag_Copy)

  ;- Bilder
  CatchImage(#Image_background, ?File_background)
  CatchImage(#Image_ch1, ?File_ch1)
  CatchImage(#Image_ch2, ?File_ch2)
;   CatchImage(#Image_ch3, ?File_ch3)
;   CatchImage(#Image_ch4, ?File_ch4)
  CatchImage(#Image_chbwlim, ?File_chbwlim)
  CatchImage(#Image_chcoupac, ?File_chcoupac)
  CatchImage(#Image_chcoupdc, ?File_chcoupdc)
  CatchImage(#Image_chcoupgnd, ?File_chcoupgnd)
  CatchImage(#Image_chinvert, ?File_chinvert)
  CatchImage(#Image_chprobe, ?File_chprobe)
  CatchImage(#Image_chvolt, ?File_chvolt)
  CatchImage(#Image_timediv, ?File_timediv)
  CatchImage(#Image_trig, ?File_trig)
  CatchImage(#Image_trigauto, ?File_trigauto)
  CatchImage(#Image_trigcouphfrej, ?File_trigcouphfrej)
  CatchImage(#Image_trigcouplfrej, ?File_trigcouplfrej)
  CatchImage(#Image_trigequal, ?File_trigequal)
  CatchImage(#Image_triggreater, ?File_triggreater)
  CatchImage(#Image_triglesser, ?File_triglesser)
  CatchImage(#Image_triglevel, ?File_triglevel)
  CatchImage(#Image_trignorm, ?File_trignorm)
  CatchImage(#Image_trigoffset, ?File_trigoffset)
  CatchImage(#Image_trigpolarityneg, ?File_trigpolarityneg)
  CatchImage(#Image_trigpolaritypos, ?File_trigpolaritypos)
  CatchImage(#Image_trigpulsewidth, ?File_trigpulsewidth)
  CatchImage(#Image_trigsingle, ?File_trigsingle)
  CatchImage(#Image_trigslopefall, ?File_trigslopefall)
  CatchImage(#Image_trigsloperise, ?File_trigsloperise)
  CatchImage(#Image_trigsloperisefall, ?File_trigsloperisefall)
  CatchImage(#Image_trigsourcealter, ?File_trigsourcealter)
  CatchImage(#Image_trigsourceext, ?File_trigsourceext)
  CatchImage(#Image_trigsourceline, ?File_trigsourceline)
  CatchImage(#Image_trigtypeedge, ?File_trigtypeedge)
  CatchImage(#Image_trigtypepulse, ?File_trigtypepulse)
  
  ;- Popup-Menü Cursor-Messung
  If CreatePopupMenu(#Menu_MDIWndCursorMeasurement)
    MenuItem(#MenuItem_MDIWndPeak, "&Spitzenwerte")
    MenuItem(#MenuItem_MDIWndRMS, "&Effektivwerte")
    MenuItem(#MenuItem_MDIWndMean, "&Mittelwerte")
  EndIf
  
  ;- Menüleiste
  If CreateMenu(#Menu_MainWnd, WindowID(#Window_Main))
  
    ; Menütitel "Datei"
    MenuTitle("&Datei")
      MenuItem(#MenuItem_MainWndLoadFile, "&Öffnen..."+#TAB$+"Strg+O")
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control|#PB_Shortcut_O, #MenuItem_MainWndLoadFile)
      MenuBar()
      MenuItem(#MenuItem_MainWndPrint, "&Drucken..."+#TAB$+"Strg+P")
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control|#PB_Shortcut_P, #MenuItem_MainWndPrint)
      OpenSubMenu("&Export als Bild")
        MenuItem(#MenuItem_MainWndExportImageFile, "&Datei..."+#TAB$+"Strg+F")
        AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control|#PB_Shortcut_F, #MenuItem_MainWndExportImageFile)
        MenuItem(#MenuItem_MainWndExportImageClipboard, "&Zwischenablage"+#TAB$+"Strg+C")
        AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control|#PB_Shortcut_C, #MenuItem_MainWndExportImageClipboard)
      CloseSubMenu()
      MenuItem(#MenuItem_MainWndExportCSVFile, "Export als &CSV-Datei..."+#TAB$+"Strg+E")
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control|#PB_Shortcut_E, #MenuItem_MainWndExportCSVFile)
      MenuItem(#MenuItem_MainWndExportLTspiceRAWFile, "Export als &LTspice-RAW-Datei..."+#TAB$+"Strg+L")
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control|#PB_Shortcut_L, #MenuItem_MainWndExportLTspiceRAWFile)
      MenuBar()
      MenuItem(#MenuItem_MainWndQuit, "&Beenden")
    
    ; Menütitel "Fenster"
    MenuTitle("&Fenster")
      MenuItem(#MenuItem_MainWndTileVertically, "&Nebeneinander")
      MenuItem(#MenuItem_MainWndTileHorizontally, "&Übereinander")
      MenuItem(#MenuItem_MainWndCascade, "&Kaskadieren")
      MenuItem(#MenuItem_MainWndCloseAll, "&Alle schließen")
    
    ; Menütitel "?"
    MenuTitle("&?")
      MenuItem(#MenuItem_MainWndOpenHelp, "&Hilfe..."+#TAB$+"F1")
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_F1, #MenuItem_MainWndOpenHelp)
      MenuItem(#MenuItem_MainWndAbout, "&Über "+#AppName+"...")
      MenuBar()
      MenuItem(#MenuItem_MainWndOpenWebsite, "&Website öffnen...")
      
  EndIf
  
  ;- Gadgets
  MDIGadget(#MDI_MainWnd, 0, 0, 0, 0, 1, #MenuItem_MainWndMDIWindowList, #PB_MDI_AutoSize|#PB_MDI_BorderLess)
    SetGadgetAttribute(#MDI_MainWnd, #PB_MDI_Image, ImageID(#Image_background))
    SetGadgetAttribute(#MDI_MainWnd, #PB_MDI_TileImage, 1)
  
  ; Per Parameter übergebene Dateien laden
  For n = CountProgramParameters() - 1 To 0 Step -1
    LoadFile(ProgramParameter(n))
  Next

  ;- Hauptschleife
  Repeat
    
    Event = WaitWindowEvent()
    
    Select EventWindow()
    
      ;- Ereignisse im Hauptfenster
      Case #Window_Main
      
        Select Event
        
          ;- > Schließen
          Case #PB_Event_CloseWindow ; Schließen
            Quit = #True

          ;- > Drag'n'drop
          Case #PB_Event_WindowDrop
            If EventDropType() = #PB_Drop_Files
              FileName$ = EventDropFiles()
              For n = CountString(FileName$, #LF$) + 1 To 1 Step -1
                LoadFile(StringField(FileName$, n, #LF$))
              Next
            EndIf
          
          ;- > Menü-Ereignis
          Case #PB_Event_Menu
          
            Select EventMenu()
            
              ; Datei -> Öffnen
              Case #MenuItem_MainWndLoadFile
                OpenFileDialog("", "", "UTD2052CEL, UTD2102CEL (*.sav)|*.sav|Alle Dateien (*.*)|*.*", 0, WindowID(#Window_Main), "sav", #OpenFileDialog_DefaultTitle|#OpenFileDialog_AddToRecent|#OpenFileDialog_FileDoesntExistWarning|#OpenFileDialog_MultiSelection)
                ForEach OpenFileDialog_FileList()
                  LoadFile(OpenFileDialog_FileList())
                Next
                
              ; Datei -> Drucken
              Case #MenuItem_MainWndPrint
                If SelectMDIWindow(GetGadgetState(#MDI_MainWnd))
                  PrintDialog()
                EndIf
                
              ; Datei -> Export als Bild -> Datei
              Case #MenuItem_MainWndExportImageFile
                If SelectMDIWindow(GetGadgetState(#MDI_MainWnd))
                  FileName$ = SaveFileDialog("", GetPathPart(MDIWindow()\DSOData\FileName)+GetFilePart(MDIWindow()\DSOData\FileName, #PB_FileSystem_NoExtension), "PNG-Dateien (*.png)|*.png|Alle Dateien (*.*)|*.*", 0, WindowID(#Window_Main), "png", #SaveFileDialog_DefaultTitle|#SaveFileDialog_AddToRecent|#SaveFileDialog_OverwriteWarning)
                  If FileName$ <> ""
                    If Not ExportWaveformImageFile(FileName$)
                      ErrorMessage(QuickFormatString("Die Datei "+#DQUOTE$+"{0}"+#DQUOTE$+" kann nicht erstellt werden!", #FormatString_String, @FileName$))
                    EndIf
                  EndIf
                EndIf
              
              ; Datei -> Export als Bild -> Zwischenablage
              Case #MenuItem_MainWndExportImageClipboard
                If SelectMDIWindow(GetGadgetState(#MDI_MainWnd))
                  ExportWaveformImageClipboard()
                EndIf
                
              ; Datei -> Export als CSV-Datei
              Case #MenuItem_MainWndExportCSVFile
                If SelectMDIWindow(GetGadgetState(#MDI_MainWnd))
                  FileName$ = SaveFileDialog("", GetPathPart(MDIWindow()\DSOData\FileName)+GetFilePart(MDIWindow()\DSOData\FileName, #PB_FileSystem_NoExtension), "CSV-Dateien (*.csv)|*.csv|Alle Dateien (*.*)|*.*", 0, WindowID(#Window_Main), "csv", #SaveFileDialog_DefaultTitle|#SaveFileDialog_AddToRecent|#SaveFileDialog_OverwriteWarning)
                  If FileName$ <> ""
                    If Not ExportWaveformCSVFile(FileName$)
                      ErrorMessage(QuickFormatString("Die Datei "+#DQUOTE$+"{0}"+#DQUOTE$+" kann nicht erstellt werden!", #FormatString_String, @FileName$))
                    EndIf
                  EndIf
                EndIf
                
              ; Datei -> Export als LTspice-RAW-Datei
              Case #MenuItem_MainWndExportLTspiceRAWFile
                If SelectMDIWindow(GetGadgetState(#MDI_MainWnd))
                  FileName$ = SaveFileDialog("", GetPathPart(MDIWindow()\DSOData\FileName)+GetFilePart(MDIWindow()\DSOData\FileName, #PB_FileSystem_NoExtension), "LTspice-RAW-Dateien (*.raw)|*.raw|Alle Dateien (*.*)|*.*", 0, WindowID(#Window_Main), "raw", #SaveFileDialog_DefaultTitle|#SaveFileDialog_AddToRecent|#SaveFileDialog_OverwriteWarning)
                  If FileName$ <> ""
                    If Not ExportWaveformLTspiceRAWFile(FileName$)
                      ErrorMessage(QuickFormatString("Die Datei "+#DQUOTE$+"{0}"+#DQUOTE$+" kann nicht erstellt werden!", #FormatString_String, @FileName$))
                    EndIf
                  EndIf
                EndIf
            
              ; Datei -> Beenden
              Case #MenuItem_MainWndQuit
                Quit = #True
                
              ; Fenster -> Nebeneinander
              Case #MenuItem_MainWndTileVertically
                SetGadgetState(#MDI_MainWnd, #PB_MDI_TileVertically)
                
              ; Fenster -> Übereinander
              Case #MenuItem_MainWndTileHorizontally
                SetGadgetState(#MDI_MainWnd, #PB_MDI_TileHorizontally)
                
              ; Fenster -> Kaskadieren
              Case #MenuItem_MainWndCascade
                SetGadgetState(#MDI_MainWnd, #PB_MDI_Cascade)
                
              ; Fenster -> Alle schließen
              Case #MenuItem_MainWndCloseAll
                ForEach MDIWindow()
                  DestroyMDIWindow()
                Next
                
              ; ? -> Hilfe
              Case #MenuItem_MainWndOpenHelp
                FileName$ = SelfPath$ + #HelpFileName
                If FileSize(FileName$) > -1
                  OpenHelp(FileName$, "")
                Else
                  ErrorMessage(QuickFormatString("Die Datei "+#DQUOTE$+"{0}"+#DQUOTE$+" kann nicht gefunden werden!", #FormatString_String, @FileName$))
                EndIf
              
              ; ? -> Über
              Case #MenuItem_MainWndAbout
                CurrentVersion$ = VersionString(#AppVersionMajor, #AppVersionMinor, #AppVersionPatch, #AppVersionBuild)
                CompileDate$ = FormatDate("%dd.%mm.%yyyy", #AppVersionDate)
                MessageRequesterAppIcon(WindowID(#Window_Main), "Über "+#AppName, QuickFormatString(#AppName+" von "+#AppAuthor+#LF$+"Version {0}"+#LF$+"Kompiliert am {1}", #FormatString_String, @CurrentVersion$, #FormatString_String, @CompileDate$))
              
              ; ? -> Website öffnen
              Case #MenuItem_MainWndOpenWebsite
                ShellExecute_(#Null, "open", #AppHomepage, #Null, #Null, #SW_SHOWNORMAL)
                
            EndSelect
            
        EndSelect
        
      Default
        
        ;- Ereignisse in einem MDIWindow
        If SelectMDIWindow(EventWindow())
        
          Select Event
          
            ;- > Schließen
            Case #PB_Event_CloseWindow
              DestroyMDIWindow()
          
            ;- > Menü-Ereignis
            Case #PB_Event_Menu
            
              Select EventMenu()
              
                ; Spitzenwerte
                Case #MenuItem_MDIWndPeak
                  CursorMeasurement(#CursorMeasurement_Peak)
                  
                ; Effektivwerte
                Case #MenuItem_MDIWndRMS
                  CursorMeasurement(#CursorMeasurement_RMS)
              
                ; Mittelwerte
                Case #MenuItem_MDIWndMean
                  CursorMeasurement(#CursorMeasurement_Mean)

              EndSelect
              
            ;- > Gadget-Ereignis
            Case #PB_Event_Gadget
            
              Select EventGadget()
              
                ; Canvas_Waveform
                Case MDIWindow()\Canvas_Waveform
                  If MDIWindow()\EnableCursors
                    Select EventType()
                      Case #PB_EventType_LeftButtonDown
                        MDIWindow()\Cursor1 = WaveformCanvasCoordinateToDataPoint(GetGadgetAttribute(MDIWindow()\Canvas_Waveform, #PB_Canvas_MouseX))
                        MDIWindow()\Update | #UpdateMDIWindow_Cursor
                      Case #PB_EventType_RightButtonDown
                        MDIWindow()\Cursor2 = WaveformCanvasCoordinateToDataPoint(GetGadgetAttribute(MDIWindow()\Canvas_Waveform, #PB_Canvas_MouseX))
                        MDIWindow()\Update | #UpdateMDIWindow_Cursor
                    EndSelect
                    UpdateMDIWindow()
                  EndIf
              
                ; ScrollBar_Offset
                Case MDIWindow()\ScrollBar_Offset
                  MDIWindow()\Update | #UpdateMDIWindow_ScrollBar_Offset
                  UpdateMDIWindow()
                  
                ; TrackBar_Zoom
                Case MDIWindow()\TrackBar_Zoom
                  MDIWindow()\Update | #UpdateMDIWindow_TrackBar_Zoom
                  UpdateMDIWindow()
                  
                ; CheckBox "Cursor aktivieren"
                Case MDIWindow()\CheckBox_EnableCursors
                  MDIWindow()\Update | #UpdateMDIWindow_CheckBox_EnableCursors
                  UpdateMDIWindow()
                  
                ; Button "Alles auswählen"
                Case MDIWindow()\Button_SelectAll
                  ResetCursors()
                  MDIWindow()\Update | #UpdateMDIWindow_Cursor
                  UpdateMDIWindow()
                  
                ; Button "Messung"
                Case MDIWindow()\Button_CursorMeasurement
                  DisplayPopupMenuBelowGadget(#Menu_MDIWndCursorMeasurement, WindowID(MDIWindow()\Window), MDIWindow()\Button_CursorMeasurement)
                  
                ; Button "Mathematik"
                Case MDIWindow()\Button_MathFunctions
                  If MathDialog()
                    MDIWindow()\Update | #UpdateMDIWindow_DSOData_MathChannel
                    UpdateMDIWindow()
                  EndIf

              EndSelect
              
          EndSelect
          
        EndIf
        
    EndSelect
    
  Until Quit
  
EndIf

End



; ########################################
;- Binärdaten
; ########################################

DataSection
  File_background:
  IncludeBinary "background.bmp"
  File_ch1:
  IncludeBinary "ch1.ico"
  File_ch2:
  IncludeBinary "ch2.ico"
;   File_ch3:
;   IncludeBinary "ch3.ico"
;   File_ch4:
;   IncludeBinary "ch4.ico"
  File_chbwlim:
  IncludeBinary "chbwlim.ico"
  File_chcoupac:
  IncludeBinary "chcoupac.ico"
  File_chcoupdc:
  IncludeBinary "chcoupdc.ico"
  File_chcoupgnd:
  IncludeBinary "chcoupgnd.ico"
  File_chinvert:
  IncludeBinary "chinvert.ico"
  File_chprobe:
  IncludeBinary "chprobe.ico"
  File_chvolt:
  IncludeBinary "chvolt.ico"
  File_timediv:
  IncludeBinary "timediv.ico"
  File_trig:
  IncludeBinary "trig.ico"
  File_trigauto:
  IncludeBinary "trigauto.ico"
  File_trigcouphfrej:
  IncludeBinary "trigcouphfrej.ico"
  File_trigcouplfrej:
  IncludeBinary "trigcouplfrej.ico"
  File_trigequal:
  IncludeBinary "trigequal.ico"
  File_triggreater:
  IncludeBinary "triggreater.ico"
  File_triglesser:
  IncludeBinary "triglesser.ico"
  File_triglevel:
  IncludeBinary "triglevel.ico"
  File_trignorm:
  IncludeBinary "trignorm.ico"
  File_trigoffset:
  IncludeBinary "trigoffset.ico"
  File_trigpolarityneg:
  IncludeBinary "trigpolarityneg.ico"
  File_trigpolaritypos:
  IncludeBinary "trigpolaritypos.ico"
  File_trigpulsewidth:
  IncludeBinary "trigpulsewidth.ico"
  File_trigsingle:
  IncludeBinary "trigsingle.ico"
  File_trigslopefall:
  IncludeBinary "trigslopefall.ico"
  File_trigsloperise:
  IncludeBinary "trigsloperise.ico"
  File_trigsloperisefall:
  IncludeBinary "trigsloperisefall.ico"
  File_trigsourcealter:
  IncludeBinary "trigsourcealter.ico"
  File_trigsourceext:
  IncludeBinary "trigsourceext.ico"
  File_trigsourceline:
  IncludeBinary "trigsourceline.ico"
  File_trigtypeedge:
  IncludeBinary "trigtypeedge.ico"
  File_trigtypepulse:
  IncludeBinary "trigtypepulse.ico"
EndDataSection



; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = AAAAAAg
; EnableUnicode
; EnableXP
; UseIcon = utd2052celreader.ico
; Executable = ..\utd2052celreader.exe
; CurrentDirectory = ..\
; EnableBuildCount = 332
; EnableExeConstant
; IncludeVersionInfo
; VersionField0 = 0,16,1,%BUILDCOUNT
; VersionField1 = 0,16,1,%BUILDCOUNT
; VersionField2 = Nils Hintze
; VersionField3 = UTD2052CEL Reader
; VersionField4 = 0.16.1-%BUILDCOUNT (%dd.%mm.%yyyy)
; VersionField5 = 0.16.1-%BUILDCOUNT (%dd.%mm.%yyyy)
; VersionField6 = UTD2052CEL Reader
; VersionField7 = utd2052celreader
; VersionField8 = utd2052celreader.exe
; VersionField9 = © Nils Hintze
; VersionField13 = webmaster@elektronikpage.net
; VersionField14 = http://www.elektronikpage.net/utd2052celreader/
; VersionField15 = VOS_NT_WINDOWS32
; VersionField16 = VFT_APP
; VersionField17 = 0407 German (Standard)